Package: factR
Title: Functional Annotation of Custom Transcriptomes
Version: 1.15.0
Authors@R: person("Fursham", "Hamid", 
    email = "fursham.h@gmail.com", 
    role = c("aut", "cre"))
Description: factR contain tools to process and interact with custom-assembled 
    transcriptomes (GTF). At its core, factR constructs CDS information on 
    custom transcripts and subsequently predicts its functional output. 
    In addition,  factR has tools capable of plotting transcripts, 
    correcting chromosome and gene information and shortlisting new transcripts.
Depends: R (>= 4.2)
biocViews: AlternativeSplicing, FunctionalPrediction, GenePrediction
Imports: BiocGenerics (>= 0.46), Biostrings (>= 2.68), GenomeInfoDb (>=
        1.36), dplyr (>= 1.1), GenomicFeatures (>= 1.52), GenomicRanges
        (>= 1.52), IRanges (>= 2.34), purrr (>= 1.0), rtracklayer (>=
        1.60), tidyr (>= 1.3), methods (>= 4.3), BiocParallel (>=
        1.34), S4Vectors (>= 0.38), data.table (>= 1.14), rlang (>=
        1.1), tibble (>= 3.2), wiggleplotr (>= 1.24), RCurl (>= 1.98),
        XML (>= 3.99), drawProteins (>= 1.20), ggplot2 (>= 3.4),
        stringr (>= 1.5), pbapply (>= 1.7), stats (>= 4.3), utils (>=
        4.3), graphics (>= 4.3), crayon (>= 1.5)
License: file LICENSE
Encoding: UTF-8
ByteCompile: true
RoxygenNote: 7.2.1
Suggests: AnnotationHub (>= 2.22), BSgenome (>= 1.58),
        BSgenome.Mmusculus.UCSC.mm10, testthat, knitr, rmarkdown,
        markdown, zeallot, rmdformats, bio3d (>= 2.4), signalHsmm (>=
        1.5), tidyverse (>= 1.3), covr, patchwork
VignetteBuilder: knitr
LazyData: FALSE
BiocType: Software
URL: https://fursham-h.github.io/factR/
git_url: https://git.bioconductor.org/packages/factR
git_branch: devel
git_last_commit: 4d6b2ca
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:37:54 UTC; biocbuild
Author: Fursham Hamid [aut, cre]
Maintainer: Fursham Hamid <fursham.h@gmail.com>

# **factR v.1**

## Functional Annotation of Custom Transcriptomes in R

<!-- badges: start -->
[![R build status](https://github.com/fursham-h/factR/workflows/R-CMD-check/badge.svg)](https://github.com/fursham-h/factR/actions)
[![Codecov test coverage](https://github.com/fursham-h/factR/workflows/test-coverage/badge.svg)](https://github.com/fursham-h/factR/actions)
[![Codecov test coverage](https://codecov.io/gh/fursham-h/factR/branch/master/graph/badge.svg)](https://app.codecov.io/gh/fursham-h/factR?branch=master)
<!-- badges: end -->
  
## General workflow
<p align="center">
  <img src="man/figures/factR_workflow.png" width="450"/>
</p>

*factR* is a robust and easy-to-use R package with tools to process custom-assembled transcriptomes (GTF). Below are *factR*'s key functions:

* Core features 
  1. Construct transcript coding (CDS) information 
  using a reference-guided process
  2. Predict protein domains on coding transcripts
  3. Predict sensitivity of coding transcripts to Nonsense-mediated decay
* Supporting features 
  1. Match chromosome levels of query GTF/object to reference annotation
  2. Match gene_id and gene_names of query GTF to reference annotation
  3. Plot transcripts from GTF GRanges object using *wiggleplotr*
  4. Subset new transcripts from custom transcriptome

## How to install
The latest stable version can be installed directly from [Bioconductor](https://bioconductor.org/packages/release/bioc/html/factR.html):
```r
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("factR")
```

Alternatively, you may install the development version of *factR* using devtools:
```r
# install.packages("devtools")
devtools::install_github("fursham-h/factR")
```

## Getting started
See our [quickstart guide](https://fursham-h.github.io/factR/articles/quickstart.html) or our 
[full vignette](https://fursham-h.github.io/factR/articles/factR.html) on how to get started

## Acknowledgements
We thank [Kaur Alasoo](https://github.com/kauralasoo) for sharing code 
resources for *wiggleplotr* and for valuable discussions on the design 
of the package.

## Citing factR
Please cite the following references if you use factR:

1. Fursham Hamid, Kaur Alasoo, Jaak Vilo, Eugene Makeyev (2022); Functional annotation of custom transcriptomes; Methods in Molecular Biology
2. [Fursham Hamid (2022); Functional Annotation of Custom Transcriptomes; Bioconductor](https://bioconductor.org/packages/release/bioc/html/factR.html)

# Generating extdata
The extdata `sc_merged_sample.gtf.gz` contain a sample custom transcriptome
constructed from cortical neural populations from a dataset by Tasic et al. (2018).
To generate the full transcriptome, execute the download_assemble_sc.sh script:

```bash
bash download_assemble_sc.sh
```

A sample of this transcriptome was obtained by taking the first 500 genes
from chromosome 15. This is done in R:
```r
gtf <- factR::importGTF("sc_merged.gtf.gz")
chr15.genes <- unique(gtf[seqnames(gtf) == "chr15"]$gene_id)
chr15.500 <- chr15.genes[1:500]
gtf <- gtf[gtf$gene_id %in% chr15.500]
rtracklayer::export(gtf, "sc_merged_sample.gtf.gz")
```

#' Import GTF file into R
#'
#' @description
#' This function loads GTF files into R and converts it into
#'
#'
#' a wrapper to rtracklayer::import() function to conveniently
#' import GTF file into R as a GenomicRanges object.
#'
#' @param con
#' Path to GTF file
#'
#' @return
#' Imported GenomicRanges object in GTF format
#'
#' @author Fursham Hamid
#' @export
#' 
#' @examples 
#' gtf <- system.file("extdata", "sc_merged_sample.gtf.gz", package = "factR")
#' importGTF(gtf)
importGTF <- function(con) {
    if(file.exists(con)){
        infile <- try(rtracklayer::import(con, format = "GTF"), silent = TRUE)
        if (is_gtf(infile)) {
            return(infile)
        } else {
            rlang::abort(paste(con, " is not in GTF format"))
        }
    } else {
        rlang::abort(paste("File ", con, " does not exists"))
    }
    
}


#' Import FASTA file into R
#'
#' @description
#' This function is a wrapper to Biostrings::readDNAStringSet() 
#' function to import FASTA genome sequence file and simultaneously 
#' convert long chromosome names 
#' (e.g. 1 dna:chromosome chromosome:GRCm38:1:1:195471971:1 REF) 
#' to short names (e.g. 1)
#'
#' @param con
#' Path to FASTA file
#'
#' @return
#' Imported DNAStringSet object
#'
#' @author Fursham Hamid
#' @export
importFASTA <- function(con) {
    infile <- tryCatch(
        {
            Biostrings::readDNAStringSet(con)
        },
        error = function(x) {
            rlang::abort(paste(con, " not found or not in FASTA format"))
        }
    )
    names(infile) <- stringr::str_split(GenomeInfoDb::seqlevels(infile), " ") %>% 
        purrr::map_chr(`[`, 1)
    return(infile)
}

context("Test io function")

# setup GRanges
gtf <- system.file("extdata", "sc_merged_sample.gtf.gz", package = "factR")
gtf <- factR::importGTF(gtf)


test_that("Test import functionality", {
  expect_true(is_gtf(gtf))
  expect_equal(length(gtf), 8117)
  expect_error(factR::importGTF("fake.gtf"))
})

#' Internally sort each element of a GenomicRangesList
#'
#' @param x
#' GRangesList object
#' @param ...
#' Comma separated list of unquoted variable names to sort by. Variables are 
#' names of metadata columns found in GRangesList object. Use desc() to sort a
#' variable in descending order. Input can be `exonorder` to sort each element 
#' in exon order
#'
#'
#' @return
#' Sorted GRangesList object
#' @export
#'
#' @examples
#' # Load dataset
#' data(query_exons)
#' 
#' # sort elements in each GRangesList in descending coordinate order
#' query_exons_desc <- sorteach(query_exons, dplyr::desc(start))
#'
#' # sort elements in each GRangesList in its order in transcript
#' query_exons_exonorder <- sorteach(query_exons_desc, exonorder)
#'
#' # test similarity of query_exons and query_exons_exonorder
#' identical(query_exons, query_exons_exonorder)
#' @author Fursham Hamid
sorteach <- function(x, ...) {
    # define global variables
    strand <- group <- NULL
    stopifnot(is(x, "GRangesList"))
    expr <- rlang::quos(...)
    if ("~exonorder" %in% as.character(expr)) {
        index <- which("~exonorder" %in% as.character(expr))
        expr[[index]] <- rlang::quo(ifelse(strand == "-", 
                                           dplyr::desc(start), start))
    }
    return(x %>% as.data.frame() %>%
        dplyr::arrange(!!!expr) %>%
        dplyr::select(-group) %>%
        GenomicRanges::makeGRangesListFromDataFrame(
            split.field = "group_name",
            keep.extra.columns = TRUE
        ))
}

#' Internally filter each element of a GenomicRangesList
#'
#' @param x
#' GRangesList object
#' @param ...
#' Logical conditions to filter each element in the GRanges by. 
#' Multiple conditions can be provided as comma-delimited inputs
#'
#' @return
#' Filtered GRangesList object
#' @export
#'
#' @examples
#' # Load dataset
#' data(query_exons)
#' 
#' # select first element of each GRangesList item
#' filtereach(query_exons, dplyr::row_number() == 1)
#' @author Fursham Hamid
filtereach <- function(x, ...) {
    group <- NULL
    stopifnot(is(x, "GRangesList"))
    return(x %>% as.data.frame() %>%
        dplyr::group_by(group) %>%
        dplyr::filter(...) %>%
        dplyr::ungroup() %>%
        dplyr::select(-group) %>%
        GenomicRanges::makeGRangesListFromDataFrame(
            split.field = "group_name",
            keep.extra.columns = TRUE
        ))
}

#' Internally create or transform metadata of a GenomicRangesList
#'
#' @param x
#' GRangesList object
#' @param ...
#' Name-value pairs of expressions. The name of each argument will be the name
#' of a new metadata column, and the value will be its corresponding value.
#'
#' @return
#' Transformed GRangesList object
#' @export
#'
#' @examples
#' # Load dataset
#' data(query_exons)
#' 
#' # Create chr:start-end id for each entry
#' mutateeach(query_exons, id = paste0(seqnames, ":", start, "-", end))
#' @author Fursham Hamid
mutateeach <- function(x, ...) {
    group <- NULL
    stopifnot(is(x, "GRangesList"))
    return(x %>% as.data.frame() %>%
        dplyr::mutate(...) %>%
        dplyr::select(-group) %>%
        GenomicRanges::makeGRangesListFromDataFrame(
            split.field = "group_name",
            keep.extra.columns = TRUE
        ))
}

context("Test _each function")

# setup GRanges
gr1 <- GenomicRanges::GRanges(
  seqnames = "1", strand = rep("+", 5),
  ranges = IRanges(
    start = c(1, 401, 801, 1001, 1301),
    end = c(100, 500, 900, 1100, 1400)
  ),
  score = c(250, 100, 500, 750, 325)
)
gr2 <- GenomicRanges::GRanges(
  seqnames = "2", strand = rep("-", 6),
  ranges = IRanges(
    start = c(201, 401, 601, 801, 981, 1201),
    end = c(300, 500, 700, 920, 1100, 1250)
  ),
  score = c(1, 1000, 500, 50, 725, 300)
)

grl <- GenomicRanges::GRangesList("gr1" = gr1, "gr2" = gr2)

test_that("Test sorteach functionality", {
  out <- sorteach(grl, exonorder)
  expect_equal(GenomicRanges::start(out$gr1), c(1, 401, 801, 1001, 1301))
  expect_equal(GenomicRanges::start(out$gr2), c(1201, 981, 801, 601, 401, 201))

  out <- sorteach(grl, dplyr::desc(start))
  expect_equal(GenomicRanges::start(out$gr1), c(1301, 1001, 801, 401, 1))
  expect_equal(GenomicRanges::start(out$gr2), c(1201, 981, 801, 601, 401, 201))

  out <- sorteach(grl, score)
  expect_equal(GenomicRanges::start(out$gr1), c(401, 1, 1301, 801, 1001))
  expect_equal(GenomicRanges::start(out$gr2), c(201, 801, 1201, 601, 981, 401))
})

test_that("Test filtereach functionality", {
  out <- filtereach(grl, score > 500)
  expect_equal(as.numeric(lengths(out)), c(1, 2))

  out <- filtereach(grl, seqnames == "2")
  expect_equal(as.numeric(lengths(out)), 6)
})

test_that("Test mutateeach functionality", {
  out <- mutateeach(grl, mid = ceiling((end - start) / 2))
  expect_equal(unlist(out)$mid, c(50, 50, 50, 50, 50, 50, 50, 50, 60, 60, 25))

  out <- mutateeach(grl, coord = paste0(seqnames, ":", start, "-", end))
  expect_equal(unlist(out)[1, 2]$coord, "1:1-100")
})

#' Plot transcripts directly from GTF.
#'
#' @description
#' A wrapper around wiggleplotr's plotTranscripts function. 
#' See the documentation for (\code{\link[wiggleplotr]{plotTranscripts}})
#' for more information.
#'
#' @param x
#' GRanges object containing transcript annotation in GTF format
#'
#' @param ...
#' Character value of features to plot. Multiple features can be plotted by
#' entering comma-delimited values. Features will be extracted from
#' metadata gene_name, gene_id and transcript_id of the GTF. Can also be a
#' conditional statement to filter values from variables in the GTF (e.g. gene_name == "Ptbp1")
#'
#' @param rescale_introns
#' Specifies if the introns should be scaled to fixed length or not. (default: FALSE)
#' 
#' @param ncol
#' Number of columns to patch the output plots (default: 1)
#'
#' @return ggplot2 object. If multiple genes are detected, plots will be 
#' combined using patchwork
#' @export
#'
#' @author Fursham Hamid
#'
#' @examples
#' ## ---------------------------------------------------------------------
#' ## EXAMPLE USING SAMPLE DATASET
#' ## ---------------------------------------------------------------------
#' # Load datasets
#' data(query_gtf, ref_gtf)
#' 
#' viewTranscripts(query_gtf)
#' viewTranscripts(query_gtf, "transcript1")
#' viewTranscripts(ref_gtf)
#'
#' ## ---------------------------------------------------------------------
#' ## EXAMPLE USING TRANSCRIPT ANNOTATION
#' ## ---------------------------------------------------------------------
#' \donttest{
#' library(AnnotationHub)
#'
#' ## Retrieve GRCm38 trancript annotation
#' ah <- AnnotationHub()
#' GRCm38_gtf <- ah[["AH60127"]]
#'
#' ## Plot transcripts from Ptbp1 gene
#' viewTranscripts(GRCm38_gtf, "Ptbp1")
#' 
#' # Plot transcripts from Ptbp1 and Ptbp2 genes
#' viewTranscripts(GRCm38_gtf, "Ptbp1", "Ptbp2")
#' }
#'
viewTranscripts <- function(x, ..., rescale_introns = FALSE, ncol = 1) {
    
    gene_name <- gene_id <- transcript_id <- NULL
    transcript_id <- meta <- val <- n <- type <-  NULL

    # catch missing args
    mandargs <- c("x")
    passed <- names(as.list(match.call())[-1])
    if (any(!mandargs %in% passed)) {
        rlang::abort(paste(
            "missing values for",
            paste(setdiff(mandargs, passed), collapse = ", ")
        ))
    }

    # retrieve input object names
    argnames <- as.character(match.call())[-1]

    if (!is_gtf(x)) {
        rlang::abort(sprintf("`%s` is not a GTF GRanges object", argnames[1]))
    }
    
    # prepare features
    featmeta <- tryCatch(
        {
            GenomicRanges::mcols(x) %>% 
                as.data.frame() %>% 
                dplyr::select(gene_name, gene_id, transcript_id) %>% 
                dplyr::mutate(n = dplyr::row_number()) %>% 
                tidyr::gather(meta, val, -n)
        },
        error = function(e) {
            GenomicRanges::mcols(x) %>% 
                as.data.frame() %>% 
                dplyr::select(-type) %>% 
                dplyr::mutate(n = dplyr::row_number()) %>% 
                tidyr::gather(meta, val, -n)
        }
    )

    if (!missing(...)) {
        x <- tryCatch(
            {

                x[featmeta[featmeta$val %in% c(...),"n"]]
            },
            error = function(e) {
                y <- tryCatch({
                    x %>% as.data.frame() %>% 
                        dplyr::filter(...) %>% 
                        GenomicRanges::makeGRangesFromDataFrame(keep.extra.columns = TRUE)
                },
                error = function(e){
                    rlang::abort(sprintf(
                        "Variables given in ... are not found in `%s`",
                        argnames[1]
                    ))
                })
            }
        )
        if (length(x) == 0) {
            rlang::abort("No transcripts to plot")
        }
    }

    # Need to have a check for plotting multiple genes.....
    ngenes <- unique(x$gene_name)
    plot <- BiocGenerics::do.call(patchwork::wrap_plots, 
                                  lapply(ngenes, function(y){
                                      # Fetch gene exons and cdss
                                      exons <- S4Vectors::split(x[x$type == "exon" & x$gene_name == y], ~transcript_id)
                                      cdss <- S4Vectors::split(x[x$type == "CDS" & x$gene_name == y], ~transcript_id)
                                      as <- S4Vectors::split(x[x$type == "AS" & x$gene_name == y], ~transcript_id)
                                      if (length(cdss) == 0) {
                                          cdss <- NULL
                                      }
                                      
                                      
                                      # Control check for number of plotted transcripts
                                      if (length(exons) > 25) {
                                          exons <- exons[seq_len(25)]
                                          rlang::warn(sprintf("Plotting only first 25 transcripts for %s gene", y))
                                      }
                                      
                                      # main plot function
                                      suppressWarnings(wiggleplotr::plotTranscripts(
                                          exons = exons,
                                          cdss = cdss[names(cdss) %in% names(exons)],
                                          rescale_introns = rescale_introns
                                      )) + ggplot2::ggtitle(y)
                                  }))

    
    plot + patchwork::plot_layout(ncol = ncol)
}

#' Predict protein domain families from coding transcripts
#'
#' @param x
#' Can be a GRanges object containing 'CDS' features in GTF format
#'
#' Can be a GRangesList object containing CDS ranges for each transcript
#' @param fasta
#' BSgenome or Biostrings object containing genomic sequence
#' @param ...
#' Logical conditions to pass to dplyr::filter to subset transcripts for 
#' analysis. Variables are metadata information found in `x` and multiple 
#' conditions can be provided delimited by comma. 
#' Example: transcript_id == "transcript1"
#' @param plot
#' Argument whether to plot out protein domains (Default: FALSE).
#' Note: only first 20 proteins will be plotted
#' @param progress_bar
#' Argument whether to show progress bar (Default: FALSE). Useful to track
#' progress of predicting a long list of proteins.
#' @param ncores
#' Number of cores to utilise to perform prediction
#'
#' @return
#' Dataframe containing protein features for each cds entry
#'
#' @examples
#' ## ---------------------------------------------------------------------
#' ## EXAMPLE USING SAMPLE DATASET
#' ## ---------------------------------------------------------------------
#' # Load Mouse genome sequence
#' library(BSgenome.Mmusculus.UCSC.mm10)
#' 
#' # Load dataset
#' data(new_query_gtf)
#'
#' # predict domains of all CDSs in query GTF
#' predictDomains(new_query_gtf, Mmusculus, ncores=1)
#'
#' # predict domains of CDSs from Ptbp1 gene
#' predictDomains(new_query_gtf, Mmusculus, gene_name == "Ptbp1",ncores=1)
#'
#' # predict domains of CDSs from Ptbp1 gene and plot architecture out
#' predictDomains(new_query_gtf, Mmusculus, gene_name == "Ptbp1", plot = TRUE,ncores=1)
#' @author Fursham Hamid
#' @export
predictDomains <- function(x, fasta, ..., plot = FALSE, 
                           progress_bar = FALSE, ncores = 4) {

    # catch missing args
    mandargs <- c("x", "fasta")
    passed <- names(as.list(match.call())[-1])
    if (any(!mandargs %in% passed)) {
        rlang::abort(paste(
            "missing values for",
            paste(setdiff(mandargs, passed), collapse = ", ")
        ))
    }

    # get argnames and carry out checks
    argnames <- as.character(match.call())[-1]
    cds <- .extractCDSchecks(x, fasta, argnames, ...)

    # define global variables
    . <- id <- NULL

    # get sequence
    aaSeq <- .getSequence(cds, fasta)

    output_table <- .runDomainSearch(aaSeq, plot, progress_bar, ncores)

    return(output_table)
}


.extractCDSchecks <- function(cds, fasta, argnames, ...) {
    # define global variables
    exonorder <- NULL

    if (!has_consistentSeqlevels(cds, fasta, verbose = FALSE)) {
        rlang::abort(sprintf(
            "`%s` and `%s` has unmatched seqlevel styles. 
Try running: %s <- matchChromosomes(%s, %s)",
            argnames[1], argnames[2], argnames[1], argnames[1], argnames[2]
        ))
    }
    # catch wrong cds class
    if (is_gtf(cds)) {
        cds <- S4Vectors::split(cds[cds$type == "CDS"], ~transcript_id)
        if (length(cds) == 0) {
            rlang::abort(sprintf(
                "`%s` do not contain CDS information", argnames[1]
            ))
        }
    }

    if (!is(cds, "GRangesList")) {
        rlang::abort("cds class type is not GRanges GTF or GRangesList")
    }

    cds <- filtereach(cds, ...)
    if (length(cds) == 0) {
        rlang::abort("No CDS to display")
    }
    return(sorteach(cds, exonorder))
}


.getSequence <- function(cds, fasta) {
    x <- y <- instop <- NULL
    
    rlang::inform("Checking CDSs and translating protein sequences")
    cdsSeq <- GenomicFeatures::extractTranscriptSeqs(fasta, cds)
    aaSeq <- suppressWarnings(
        Biostrings::translate(cdsSeq, if.fuzzy.codon = "solve")) %>%
        as.data.frame() %>%
        tibble::rownames_to_column("id") %>%
        dplyr::rowwise() %>%
        dplyr::mutate(y = strsplit(x, split = "")) %>%
        dplyr::mutate(noATG = ifelse(y[[1]] != "M", TRUE, FALSE)) %>%
        dplyr::mutate(instop = ifelse("*" %in% y, TRUE, FALSE)) %>%
        dplyr::ungroup()

    # check for ATG and internal stop_codon, truncate proteins with internal 
    # stop codon
    ## and remove entries without proteins after truncation
    if (TRUE %in% aaSeq$noATG) {
        rlang::warn(sprintf("%s CDSs do not begin with ATG", sum(aaSeq$noATG)))
    }
    if (TRUE %in% aaSeq$instop) {
        aaSeq <- suppressWarnings(aaSeq %>%
            dplyr::rowwise() %>%
            dplyr::mutate(x = ifelse(instop == TRUE,
                paste(y[seq_len(which(y == "*") - 1)], collapse = ""),
                x
            )) %>%
            dplyr::mutate(y = strsplit(x, split = "")) %>%
            dplyr::ungroup())

        rlang::warn(sprintf(paste0("%s CDSs contain internal stop codon. ",
                                   "Truncating CDS sequence to retain ORF"), 
                            sum(aaSeq$instop)))
        if ("" %in% aaSeq$x) {
            rlang::warn(sprintf(paste0(
                "After truncation, %s cds have no ",
                "coding sequences. These CDSs were not analyzed"), 
                sum(aaSeq$x == "")))
            aaSeq <- aaSeq[aaSeq$x != "", ]
        }
    }
    rlang::inform(sprintf(
        "Predicting domain families for %s proteins", nrow(aaSeq)))
    return(aaSeq)
}



.getdomains <- function(url, curl.opts, seq, id, length, n) {
    type <- famdesc <- fameval <- begin <- NULL
    
    hmm <- ""
    while(!grepl("data name=\"results\"", hmm)){
        hmm <- RCurl::postForm(url,
                               hmmdb = "superfamily", seqdb = NULL,
                               seq = seq, style = "POST", .opts = curl.opts,
                               .contentEncodeFun = RCurl::curlPercentEncode,
                               .checkParams = TRUE
        )
        if (grepl("status=\"PEND\"", hmm)) {
            Sys.sleep(30)
        }
    }

    xml <- XML::xmlParse(hmm)
    domains <- XML::xpathSApply(xml, "///domains", XML::xpathSApply, "@*")
    family <- XML::xpathSApply(xml, "///family", XML::xpathSApply, "@*")
    family[2,] <- domains['alihmmdesc',]
    segment <- XML::xpathSApply(xml, "///segments", XML::xpathSApply, "@*")

    if (ncol(family) != ncol(segment)) {
        ndomains <- XML::xpathSApply(xml, "///domains", 
                                     XML::xpathSApply, "count(segments)")
        family2 <- suppressMessages(lapply(seq_along(ndomains), function(x) {
            return(family[, rep(x, each = ndomains[x])])
        }) %>% dplyr::bind_cols() %>% as.matrix())
        rownames(family2) <- rownames(family)
        data <- rbind(family2, segment)
    } else {
        data <- rbind(family, segment)
    }

    data <- as.data.frame(t(data), stringsAsFactors = FALSE) %>%
        dplyr::mutate(type = "DOMAIN", 
                      begin = as.numeric(start), 
                      end = as.numeric(end)) %>%
        dplyr::select(type, description = famdesc, 
                      eval = fameval, begin, end) %>%
        dplyr::mutate(entryName = id)
    # dplyr::mutate(order = n)
    return(data)
}

.runDomainSearch <- function(aaSeq, plot, progress_bar, ncores) {
    type <- entryName <- description <- begin <- id <- NULL

    # prepare URL
    url <- paste("https://www.ebi.ac.uk/Tools/hmmer/search/hmmscan")
    url.opts <- list(
        httpheader = "Expect:", httpheader = "Accept:text/xml",
        verbose = FALSE, followlocation = TRUE
    )

    # run search for each protein sequence
    output <- BiocParallel::bplapply(seq_len(nrow(aaSeq)), function(y) {
        # account for return errors
        report <- tryCatch(
            .getdomains(url, url.opts, aaSeq[y, ]$x, 
                        aaSeq[y, ]$id, nchar(aaSeq[y, ]$x), y),
            error = function(e) NULL
        )

        if (is.null(report)) {
            return(tibble::tibble(type = "CHAIN", 
                                  description = aaSeq[y, ]$id, 
                                  begin = 1, 
                                  end = nchar(aaSeq[y, ]$x), 
                                  entryName = aaSeq[y, ]$id))
        } else {
            return(dplyr::bind_rows(
                report,
                tibble::tibble(type = "CHAIN", 
                               description = aaSeq[y, ]$id, 
                               begin = 1, 
                               end = nchar(aaSeq[y, ]$x), 
                               entryName = aaSeq[y, ]$id)
            ))
        }
    }, BPPARAM = BiocParallel::MulticoreParam(progressbar = progress_bar,
                                              workers = ncores)) %>%
        dplyr::bind_rows()

    # plot protein domains if requested
    if (plot) {
        datatoplot <- output %>%
            dplyr::left_join(
                output %>%
                    dplyr::select(entryName) %>%
                    dplyr::distinct() %>%
                    dplyr::mutate(order = dplyr::row_number()),
                by = "entryName"
            )
        if (max(datatoplot$order) > 20) {
            datatoplot <- datatoplot[datatoplot$order <= 20, ]
            rlang::warn("Plotting only first 20 proteins")
        }

        print(drawProteins::draw_canvas(datatoplot) %>%
            drawProteins::draw_chains(datatoplot) %>%
            drawProteins::draw_domains(datatoplot, label_domains = FALSE) +
            ggplot2::theme_bw() + # white background
            ggplot2::theme(
                panel.grid.minor = ggplot2::element_blank(),
                panel.grid.major = ggplot2::element_blank()
            ) +
            ggplot2::theme(
                axis.ticks = ggplot2::element_blank(),
                axis.text.y = ggplot2::element_blank()
            ) +
            ggplot2::theme(panel.border = ggplot2::element_blank()))
    }

    # prepare output table
    if ("DOMAIN" %in% output$type) {
        table.out <- output %>%
            tibble::as_tibble() %>%
            dplyr::filter(type == "DOMAIN") %>%
            dplyr::select(transcript = entryName, description, 
                          eval, begin, end)

    } else {
        return(NULL)
    }
}

#' Match gene metadata from query GTF to a reference GTF
#'
#' @description
#' `matchGeneInfo()` matches and corrects Gene IDs from a 
#' query GTF object to a reference GTF
#'
#' @details
#' The default approach to this correction relies on finding overlaps 
#' between transcripts in query with transcripts in reference. Using this 
#' method alone could result in false positive matches 
#' (19 percent false positives).
#' To improve this, users have the option to invoke two additional layers 
#' of matching.  
#' (1) Matching by ENSEMBL Gene_IDs. If both query and reference transcript 
#' annotations containg Ensembl-style Gene IDs, this program will try to 
#' match both IDs in a less stringent manner. This correction can be invoked
#' by providing the 'primary_gene_id' argument
#'
#' (2) Matching by secondary Gene_IDs. Depending on the transcript assembly 
#' program, GTF/GFF3 annotations may contain additional comments on the
#' transcript information. This may include a distinct secondary Gene ID 
#' annotation that potentially matches with the reference. To invoke this 
#' correction, provide 'primary_gene_id' and 'secondary_gene_id' arguments. 
#' To determine if your transcript assembly contain possible secondary 
#' Gene IDs, import query GTF file using `importGTF()` and check its metadata
#' columns
#'
#'
#' @param query
#' Query GTF imported as GRanges object
#' @param ref
#' Reference GTF as GRanges object
#' @param primary_gene_id
#' Character name of the primary gene id metadata in query GTF.
#' Input to this argument is typically 'gene_id'
#' @param secondary_gene_id
#' Character name of the secondary gene id in query file.
#' Example of input to this argument is 'ref_gene_id'
#'
#' @return
#' Gene_id-matched query GRanges
#' @export
#'
#' @examples
#' ## ---------------------------------------------------------------------
#' ## EXAMPLE USING SAMPLE DATASET
#' ## ---------------------------------------------------------------------
#' # Load datasets
#' data(chrom_matched_query_gtf, ref_gtf)
#' 
#' # Run matching function
#' matchGeneInfo(chrom_matched_query_gtf, ref_gtf)
#' @author Fursham Hamid

matchGeneInfo <- function(query, ref,
                          primary_gene_id = NULL,
                          secondary_gene_id = NULL) {

    # define global variables
    matched <- gene_id <- transcript_id <- matched <- match_level <- NULL
    type <- NULL


    # retrieve input object names and perform input chekcs
    argnames <- as.character(match.call())[-1]
    .matchgeneinfochecks(query, ref)


    # prepare a df with a list of gene_ids found in reference
    ref.genelist <- ref %>%
        as.data.frame() %>%
        dplyr::select(gene_id) %>%
        dplyr::distinct() %>%
        dplyr::mutate(matched = TRUE) 

    # convert input GRanges object to dataframe for 
    # parsing and adding meta information
    query <- query %>%
        as.data.frame() %>%
        dplyr::filter(type != "gene") %>%
        dplyr::mutate(old_gene_id = gene_id, match_level = 0) %>%
        dplyr::left_join(ref.genelist, by = "gene_id")


    # count number of non standard ID before correction
    nonstand_before <- query %>%
        dplyr::distinct(gene_id, .keep_all = TRUE) %>%
        dplyr::filter(is.na(matched)) %>%
        nrow()
    rlang::inform(italic(sprintf("    Number of mismatched gene_ids found: %s", 
                          nonstand_before)))
    
    
    ###########################################################################
    # this function will attempt to match gene_ids from input to reference
    #   there are 2 optional matching functions and 1 constitutive matching 
    #   function the optional sub-function can be invoked by providing 
    #   primary_gene_id and secondary_gene_id (matching 1)or by providing 
    #   primary_gene_id only (matching 2) depending on the the degree of 
    #   matching done, a match_level is assigned and the number represents:
    #     0 -> ids are found in ref;
    #     1 -> ids are matched by secondary_gene_id
    #     2 -> ids are matched by appending ENS... suffix
    #     3 -> ids are matched by secondary_gene_id followed by appending ENS..
    #     4 -> ids are matched by matching overlapping coordinates
    #     5 -> id could not be matched and will be skipped from analysis
    ##########################################################################
    
    # Matching function 1: replace primary_gene_id with secondary_gene_id, 
    # IF both args are provided
    if (!is.null(primary_gene_id) & !is.null(secondary_gene_id)) {
        query <- .matchfunction1(query, ref, primary_gene_id, 
                                 secondary_gene_id) 
    }

    # Matching function 2: replace primary_gene_id with basic gene ID IF:
    # at least primary_gene_id is provided and if it starts with 'ENS'
    if (!is.null(primary_gene_id)) {
        query <- .matchfunction2(query, ref, primary_gene_id)
    }
    
    # Matching function 3: correct gene_ids by finding overlapping regions.
    query <- .matchfunction3(query, ref, ref.genelist)

    # Perform post-matching functions and return object
    return(.postmatching(query, ref, nonstand_before))
}

.matchgeneinfochecks <- function(query, ref, argnames) {
    
    
    # catch unmatched seqlevels
    if (suppressWarnings(!has_consistentSeqlevels(query, ref))) {
        rlang::abort(sprintf(
            "`%s` and `%s` has unmatched seqlevel styles. 
Try running: %s <- matchChromosomes(%s, %s)",
            argnames[1], argnames[2], argnames[1], argnames[1], argnames[2]
        ))
    } else {
        outmsg <- has_consistentSeqlevels(query, ref)
    }
}

.matchfunction1 <- function(query, ref, primary_gene_id, secondary_gene_id) {
    gene_id <- matched <- match_level <- NULL
    # Matching function 1: replace primary_gene_id with secondary_gene_id, 
    #IF both args are provided
    # count number of non-standard ids before matching
    countsbefore <- query %>%
        dplyr::distinct(gene_id, .keep_all = TRUE) %>%
        dplyr::filter(is.na(matched)) %>%
        nrow()
    
    
    # proceed with matching only if there are unmatched gene ids
    if (countsbefore > 0) {
        rlang::inform(italic(sprintf(
            "    -> Attempting to correct gene ids by replacing %s with %s...",
            primary_gene_id, secondary_gene_id
        )))
        
        # prepare a df with a list of gene_ids found in reference
        ref.genelist.1 <- ref %>%
            as.data.frame() %>%
            dplyr::select(gene_id) %>%
            dplyr::distinct() %>%
            dplyr::mutate(matched = TRUE)
        
        # core of the function.
        #   this will replace the primary_gene_id with the secondary_gene_id 
        #   and change the match_level of matched transcripts to 1
        query <- suppressMessages(
            query %>% 
                dplyr::mutate(
                    !!primary_gene_id := ifelse(
                        is.na(matched) & !is.na(get(secondary_gene_id)),
                        get(secondary_gene_id), 
                        get(primary_gene_id))
                    ) %>%
                dplyr::mutate(
                    match_level = ifelse(
                        is.na(matched) & !is.na(get(secondary_gene_id)),
                        1,
                        match_level)
                              ) %>%
                dplyr::select(-matched) %>%
                dplyr::left_join(ref.genelist.1))
        
        
        # count number of non-standard ids after matching
        countsafter <- query %>%
            dplyr::distinct(gene_id, .keep_all = TRUE) %>%
            dplyr::filter(is.na(matched)) %>%
            nrow()
        if (countsafter > countsbefore) {
            countsafter <- countsbefore
        } 
        
        # report number of IDs corrected
        rlang::inform(italic(sprintf(
            "    -> %s gene_ids matched",
            (countsbefore - countsafter)
        )))
    }
    return(query)
}

.matchfunction2 <- function(query, ref, primary_gene_id) {
    gene_id <- matched <- match_level <- appended_ens_id <- NULL
    transcript_id <- basic_gene_id <- matched1 <- NULL
    # Matching function 2: replace primary_gene_id with basic gene ID IF:
    # count number of non-standard ids before matching
    countsbefore <- query %>%
        dplyr::distinct(gene_id, .keep_all = TRUE) %>%
        dplyr::filter(is.na(matched)) %>%
        nrow()
    
    # proceed with matching only if there are unmatched gene ids
    if (countsbefore > 0) {
        rlang::inform(italic("    --> Attempting to match ensembl gene_ids..."))
        # prepare a df with a list of reference gene_ids and append 
        # ENSEMBL style ids to remove suffixes
        ref.genelist.2 <- ref %>%
            as.data.frame() %>%
            dplyr::select(gene_id) %>%
            dplyr::distinct() %>%
            dplyr::mutate(matched = TRUE) %>%
            dplyr::mutate(appended_ens_id = ifelse(
                startsWith(gene_id, "ENS"),
                stringr::str_remove(gene_id, pattern = "\\.[0-9]+$"), 
                NA
            )) %>%
            dplyr::filter(!is.na(appended_ens_id)) %>%
            dplyr::select(appended_ens_id, basic_gene_id = gene_id, 
                          matched1 = matched)
        
        # core of the function.
        #   this function will append ENSEMBL style primary_gene_ids 
        #   to remove suffixes and match those gene_ids to the appended
        #   reference gene_ids and change the match_level 
        #   of matched transcripts
        query <- suppressMessages(
            query %>%
                dplyr::group_by(transcript_id) %>% 
                dplyr::mutate(appended_ens_id = ifelse(
                    startsWith(get(primary_gene_id), "ENS") & is.na(matched), 
                    stringr::str_remove(get(primary_gene_id), pattern = "\\.[0-9]+$"),
                    as.character(NA))) %>%
                dplyr::left_join(ref.genelist.2) %>%
                dplyr::mutate(!!primary_gene_id := ifelse(
                    !is.na(basic_gene_id),  
                    basic_gene_id,
                    get(primary_gene_id))) %>%
                dplyr::mutate(match_level = ifelse(
                    !is.na(basic_gene_id),match_level + 2,   match_level)) %>%
                dplyr::mutate(matched = ifelse(
                    !is.na(basic_gene_id),matched1, matched)) %>%
                dplyr::select(-appended_ens_id, -basic_gene_id, -matched1) %>%
                dplyr::ungroup())
        
        # count number of non-standard ids after matching
        countsafter <- query %>%
            dplyr::distinct(gene_id, .keep_all = TRUE) %>%
            dplyr::filter(is.na(matched)) %>%
            nrow()
        
        # print out statistics of the match
        #   or print out warning if none of the genes were matched
        if (countsbefore > countsafter) {
            rlang::inform(italic(sprintf("    --> %s gene_ids matched", 
                                  (countsbefore - countsafter))))
        } else {
            anyEnsid <- query %>%
                dplyr::select(gene_id) %>%
                dplyr::distinct() %>%
                dplyr::filter(startsWith(gene_id, "ENS")) %>%
                nrow() > 0
            
            if (anyEnsid == TRUE) {
                rlang::inform(italic(
                    "    --> All ensembl gene ids have been matched"))
            } else {
                rlang::inform(italic(
                    "    --> No ensembl gene ids found in query"))
            }
        }
    }
    return(query)
}

.matchfunction3 <- function(query, ref, ref.genelist) {
    gene_id <- matched <- match_level <- unmatched_granges.start <- NULL
    transcript_id <- basic_gene_id <- matched1 <- type <- NULL
    seqnames <- strand <- unmatched_granges.end <- ref.end <- NULL
    ref.start <- basic_gene_id <- NULL
    
    # Matching function 3: correct gene_ids by finding overlapping regions.
    
    # count number of unmatched ids before matching
    countsbefore <- query %>%
        dplyr::distinct(gene_id, .keep_all = TRUE) %>%
        dplyr::filter(is.na(matched)) %>%
        nrow()
    
    if (countsbefore == 0) {
        rlang::inform(italic("    --> All gene ids have been matched"))
    } else {
        rlang::inform(italic(paste0("    ---> Attempting to match gene_ids by" ,
                             " finding overlapping coordinates...")))
        # core of the function.
        #   this function will gather all unmatched transcripts
        #   and attempt to find its overlap with the reference
        #   and match those gene_ids to the reference gene_ids
        #   and change the match_level of matched transcripts
        unmatched_df <- query %>%
            dplyr::filter(is.na(matched), type == "transcript") %>%
            dplyr::distinct(transcript_id, .keep_all = TRUE) %>%
            dplyr::select(seqnames, start, end, strand, transcript_id)
        unmatched_granges <- GenomicRanges::makeGRangesFromDataFrame(
            unmatched_df, keep.extra.columns = TRUE)
        
        matched_df <-  suppressWarnings(IRanges::mergeByOverlaps(unmatched_granges, ref) %>%
            as.data.frame() %>%
            dplyr::mutate(offset = abs(unmatched_granges.end - ref.end) + 
                              abs(unmatched_granges.start - ref.start)) %>%
            dplyr::arrange(offset) %>%
            dplyr::select(transcript_id, basic_gene_id = gene_id) %>%
            dplyr::distinct(transcript_id, .keep_all = TRUE))
        
        query <- suppressMessages(
            query %>%  
                dplyr::select(-matched) %>%
                dplyr::left_join(matched_df) %>%
                dplyr::mutate(gene_id = ifelse(
                    !is.na(basic_gene_id),basic_gene_id, gene_id)) %>%
                dplyr::mutate(match_level = ifelse(
                    !is.na(basic_gene_id),4, match_level)) %>%
                dplyr::select(-basic_gene_id) %>%
                dplyr::left_join(ref.genelist))
        
        # count number of unmatched ids after matching
        countsafter <- query %>%
            dplyr::distinct(gene_id, .keep_all = TRUE) %>%
            dplyr::filter(is.na(matched)) %>%
            nrow()
        
        
        # report statistics of the match
        rlang::inform(italic(sprintf("    ---> %s gene_id matched", 
                              (countsbefore - countsafter))))
    }
    return(query)
}

.postmatching <- function(query, ref, nonstand_before) {
    matched <- match_level <- gene_id <- gene_name <- ref_gene_name <- NULL
    ## post matching function
    # annotate the match_level on unmatched gene_ids
    # and cleanup the dataframe
    query <- query %>%
        dplyr::mutate(match_level = ifelse(is.na(matched),
                                           5, match_level
        )) %>%
        dplyr::select(-matched)
    
    if ("gene_name" %in% names(S4Vectors::mcols(ref))) {
        ref.genelist.1 <- ref %>%
            as.data.frame() %>%
            dplyr::select(gene_id, ref_gene_name = gene_name) %>%
            dplyr::distinct()
        
        query <- query %>%
            dplyr::left_join(ref.genelist.1, by = "gene_id") %>%
            dplyr::mutate(gene_name = ref_gene_name) %>%
            dplyr::select(-ref_gene_name)
    }
    
    # report pre-testing analysis and return query
    nonstand_after <- query %>%
        dplyr::distinct(gene_id, .keep_all = TRUE) %>%
        dplyr::filter(match_level == 5) %>%
        nrow()
    corrected_ids <- nonstand_before - nonstand_after
    
    rlang::inform(italic(sprintf("    Total gene_ids corrected: %s", corrected_ids)))
    rlang::inform(italic(sprintf("    Remaining number of mismatched gene_ids: %s", 
                          nonstand_after)))
    
    query <- GenomicRanges::makeGRangesFromDataFrame(query, 
                                                     keep.extra.columns = TRUE)
    return(query)
}

context("Test matching functions")

data(query_gtf)
data(ref_gtf)

matched1 <- matchChromosomes(query_gtf, ref_gtf)
matched2 <- matchGeneInfo(matched1, ref_gtf)

test_that("Test the structure of outputs", {
  expect_equal(is(matched1, "GRanges"), TRUE)
  expect_equal(is(matched2, "GRanges"), TRUE)
  expect_equal(length(matched1), 56)
  expect_equal(length(matched2), 56)
  expect_equal(names(S4Vectors::mcols(matched2)), c(
    "type", "transcript_id", "gene_id", "gene_name",
    "old_gene_id", "match_level"
  ))
})

test_that("Test the value of outputs", {
  expect_equal(as.character(GenomeInfoDb::seqnames(matched1))[1], "chr10")
  expect_equal(unique(mcols(matched2)$gene_id), "ENSMUSG00000006498.14")
  expect_equal(unique(mcols(matched2)$match_level), 4)
})

#' Resize 5' and 3' ends of a transcript GenomicRanges
#'
#' @param x
#' GRanges or GRangesList object containing exon coordinates for each transcript
#' @param start
#' Number of bases to trim from the start of transcript. Providing a negative 
#' value will extend the transcript instead. If `x` is a GRanges object,
#' `start` is a single integer. If `x` is a GRangesList, `start` can be a single
#' integer or a list of integers of the same length as `x`
#' @param end
#' Number of bases to trim from the end of transcript. Providing a negative 
#' value will extend the transcript instead. If `x` is a GRanges object,
#' `end` is a single integer. If `x` is a GRangesList, `end` can be a single
#' integer or a list of integers of the same length as `x`
#'
#' @return Trimmed GenomicRanges object
#' @export
#' @author Fursham Hamid
#'
#' @examples
#' library(GenomicRanges)
#' gr1 <- GRanges(
#'   seqnames = "chr1", strand = c("+", "+", "+"),
#'   ranges = IRanges(
#'     start = c(1, 500, 1000),
#'     end = c(100, 600, 1100)
#'   )
#' )
#'
#' trimTranscripts(gr1, 20, 80)
#' trimTranscripts(gr1, 110, 150)
trimTranscripts <- function(x, start = 0, end = 0) {

    # define global variables
    width <- tmp.fwdcumsum <- tmp.revcumsum <- tmp.end <- tmp.start <- NULL
    strand <- group <- tmp.headlength <- tmp.taillength <- group_name <- NULL

    # check inputs
    if (is(x, "GRanges")) {
        type <- "GR"
        x <- GenomicRanges::GRangesList(x)
    } else if (is(x, "GRangesList")) {
        type <- "GRlist"
    } else {
        rlang::abort("x is not of class GRanges or GRangesList")
    }
    if (length(start) == 1) {
        start <- rep(start, length(x))
    } else if (length(start) != length(x)) {
        startlen <- length(start)
        xlen <- length(x)
        rlang::abort(sprintf("Length of `start` (%s) is not equal to `x` (%s)", 
                             startlen, xlen))
    }
    if (length(end) == 1) {
        end <- rep(end, length(x))
    } else if (length(end) != length(x)) {
        endlen <- length(end)
        xlen <- length(x)
        rlang::abort(sprintf("Length of `end` (%s) is not equal to `x` (%s)", 
                             endlen, xlen))
    }

    # return if appending length is longer than transcript
    if (any(sum(BiocGenerics::width(x)) < (start + end))) {
        rlang::abort("Appending length is greater than size of transcript")
    }


    # retrieve strand information
    strandList <- as.character(S4Vectors::runValue(BiocGenerics::strand(x)))

    # subsequently,we will treat granges as forward stranded
    # so if granges is initially on rev strand, we will swap
    trim_df <- tibble::tibble(
        strand = rep(strandList, lengths(x)),
        start = rep(start, lengths(x)),
        end = rep(end, lengths(x))
    )
    trim_df <- trim_df %>%
        dplyr::mutate(tmp.headlength = ifelse(strand == "-", end, start)) %>%
        dplyr::mutate(tmp.taillength = ifelse(strand == "-", start, end)) %>%
        dplyr::select(-strand, -start, -end)


    x <- x %>%
        as.data.frame() %>%
        dplyr::bind_cols(trim_df) %>%
        dplyr::group_by(group) %>%
        dplyr::arrange(start) %>%
        dplyr::mutate(
            tmp.fwdcumsum = cumsum(width) - tmp.headlength,
            tmp.revcumsum = rev(cumsum(rev(width))) - tmp.taillength,
            tmp.start = start,
            tmp.end = end
        ) %>%
        dplyr::filter(tmp.fwdcumsum > 0 & tmp.revcumsum > 0) %>%
        dplyr::mutate(
            start = ifelse(dplyr::row_number() == 1, 
                           tmp.end - tmp.fwdcumsum + 1, start),
            end = ifelse(dplyr::row_number() == dplyr::n(), 
                         tmp.start + tmp.revcumsum - 1, end)
        ) %>%
        dplyr::arrange(ifelse(strand == "-", dplyr::desc(start), start)) %>%
        dplyr::select(-dplyr::starts_with("tmp.")) %>%
        dplyr::ungroup()

    # format output
    if (type == "GR") {
        x <- x %>%
            dplyr::select(-group, -group_name) %>%
            GenomicRanges::makeGRangesFromDataFrame(keep.extra.columns = TRUE)
    } else if (type == "GRlist") {
        x <- x %>%
            dplyr::select(-group) %>%
            GenomicRanges::makeGRangesListFromDataFrame(
                keep.extra.columns = TRUE,
                split.field = "group_name"
            )
    }

    return(x)
}

context("Test trimTranscripts function")

# setup GRanges
gr1 <- GenomicRanges::GRanges(
  seqnames = "chr1", strand = c("+", "+", "+"),
  ranges = IRanges(
    start = c(1, 500, 1000),
    end = c(100, 600, 1100)
  )
)
gr2 <- GenomicRanges::GRanges(
  seqnames = "chr1", strand = c("-", "-", "-"),
  ranges = IRanges(
    start = c(1, 500, 1000),
    end = c(100, 600, 1100)
  )
)
grl <- GenomicRanges::GRangesList(gr1 = gr1, gr2 = gr2)

out1 <- trimTranscripts(gr1, 20, 80)
out2 <- trimTranscripts(gr2, 20, 80)
out3 <- trimTranscripts(gr1, 110, 150)
out4 <- trimTranscripts(gr2, 110, 150)

out5 <- trimTranscripts(grl, 20, 80)
out6 <- trimTranscripts(grl, c(20, 110))


test_that("Test sample output", {
  expect_equal(BiocGenerics::start(out1), c(21, 500, 1000))
  expect_equal(BiocGenerics::end(out1), c(100, 600, 1020))

  expect_equal(BiocGenerics::start(out2), c(1000, 500, 81))
  expect_equal(BiocGenerics::end(out2), c(1080, 600, 100))

  expect_equal(BiocGenerics::start(out3), 510)
  expect_equal(BiocGenerics::end(out3), 551)

  expect_equal(BiocGenerics::start(out4), 550)
  expect_equal(BiocGenerics::end(out4), 591)

  expect_equal(
    as.numeric(BiocGenerics::unlist(BiocGenerics::start(out5))),
    c(21, 500, 1000, 1000, 500, 81)
  )
  expect_equal(
    as.numeric(BiocGenerics::unlist(BiocGenerics::end(out5))),
    c(100, 600, 1020, 1080, 600, 100)
  )

  expect_equal(
    as.numeric(BiocGenerics::unlist(BiocGenerics::start(out6))),
    c(21, 500, 1000, 500, 1)
  )
  expect_equal(
    as.numeric(BiocGenerics::unlist(BiocGenerics::end(out6))),
    c(100, 600, 1100, 591, 100)
  )
})

is_gtf <- function(...) {
  type <- gene_id <- transcript_id <- NULL
  return(unlist(lapply(list(...), function(x) {
    if (is(x, "GRanges")) {
      x <- as.data.frame(x)
      if (all(c("type", "gene_id", "transcript_id") %in% names(x))) {
        x <- x %>%
          dplyr::select(type, gene_id, transcript_id) %>%
          dplyr::distinct()
        if (nrow(x) > 1) {
          return(TRUE)
        }
      }
    }
    return(FALSE)
  })))
}

context("Test is_gtf function")

data(query_gtf, query_exons)

test_that("Test the value of outputs", {
  expect_equal(is_gtf(query_gtf), TRUE)
  expect_equal(is_gtf(query_exons[1]), FALSE)
  expect_equal(is_gtf(query_exons[[1]]), FALSE)
  expect_equal(is_gtf(data.frame("name" = "Me")), FALSE)
})

#' Match seqlevels of input GRanges to reference GRanges or BioString objects
#'
#' @description
#' A convenient wrapper to match seqlevels of a query GRanges object to a 
#' reference object that contain seqlevels information. Reference can be a 
#' GRanges, GRangesList, BioString or DNAString object. Seqlevels which fail 
#' to match will be dropped.
#'
#' @param x GRanges object with seqnames to change
#' @param to GRanges object from which seqnames is referenced
#'
#' @return Corrected input GRanges
#' @export
#' @author Fursham Hamid
#'
#' @examples
#' ## ---------------------------------------------------------------------
#' ## EXAMPLE USING TOY DATASET
#' ## ---------------------------------------------------------------------
#' require(GenomicRanges)
#'
#' ## Create toy GRanges objects
#' gr1 <- GRanges("1", IRanges(start = c(1, 101), width = c(20, 20)), "+")
#' gr2 <- GRanges("chr1", IRanges(start = c(1, 101), width = c(20, 20)), "+")
#'
#' ## Match Ensembl-style chromosomes from gr1 to UCSC-style gr2
#' matchChromosomes(gr1, gr2)
#'
#' ## Possible to match chrosomomes from GRanges object to a Biostrings 
#' #    object containing seqlevels
#' x0 <- c("chr2" = "CTCACCAGTAT", "chr3" = "TGTCAGTCGA")
#' dna <- Biostrings::DNAStringSet(x0)
#'
#' ## Match gr1 to dna
#' matchChromosomes(gr1, dna)
matchChromosomes <- function(x, to) {
    nseqlevelsbefore <- length(GenomeInfoDb::seqlevels(x))
    suppressWarnings(
        if (!has_consistentSeqlevels(x, to)) {
            # attempt to match style first
            newStyle <- GenomeInfoDb::mapSeqlevels(GenomeInfoDb::seqlevels(x), (GenomeInfoDb::seqlevelsStyle(to)[1]))
            newStyle <- newStyle[!is.na(newStyle)]
            x <- GenomeInfoDb::renameSeqlevels(x, newStyle)
        }
    )
    if (length(GenomeInfoDb::seqlevels(x)) < nseqlevelsbefore) {
        nseqlevelsafter <- nseqlevelsbefore - length(GenomeInfoDb::seqlevels(x))
        rlang::warn(sprintf("%s seqlevels were removed after matching", 
                            nseqlevelsafter))
    }
    msg <- has_consistentSeqlevels(x, to)
    return(x)
}

#' Predict NMD sensitivity on mRNA transcripts
#'
#' @param x
#' Can be a GRanges object containing exon and CDS transcript features in GTF
#' format.
#'
#' Can be a GRangesList object containing exon features for a list of 
#' transcripts.If so, `cds` argument have to be provided.
#'
#' Can be a GRanges object containing exon features for a transcript. 
#' If so, `cds` argument have to be provided.
#'
#' @param ...
#' Logical conditions to pass to dplyr::filter to subset transcripts for 
#' analysis. Variables are metadata information found in `x` and multiple 
#' conditions can be provided delimited by comma. 
#' Example: transcript_id == "transcript1"
#'
#' @param cds
#' If `x` is a GRangesList object, `cds` has to be a GRangesList containing 
#' CDS features for the list of transcripts in `x`. List names in `x` and 
#' `cds` have to match.
#'
#' If `x` is a GRanges object, `cds` has to be a GRanges containing CDS 
#' features for the transcript in `x`.
#'
#' @param NMD_threshold
#' Minimum distance of stop_codon to last exon junction 
#' (EJ) which triggers NMD. Default = 50bp
#' 
#' @param progress_bar
#' Whether to display progress 
#' Default = TRUE
#'
#' @return
#' Dataframe with prediction of NMD sensitivity and NMD features:
#'
#' is_NMD: logical value in prediciting transcript sensitivity to NMD
#'
#' stop_to_lastEJ: Integer value of the number of bases between the first
#' base of the stop_codon to the last base of EJ. A positive value indicates 
#' that the last EJ is downstream of the stop_codon.
#'
#' num_of_down_EJs: Number of EJs downstream of the stop_codon.
#'
#' `3_UTR_length`: Length of 3' UTR
#'
#' @export
#' @author Fursham Hamid
#'
#' @examples
#'
#' ## ---------------------------------------------------------------------
#' ## EXAMPLE USING SAMPLE DATASET
#' ## ---------------------------------------------------------------------
#' 
#' # Load datasets
#' data(new_query_gtf, query_exons, query_cds)
#' 
#' ## Using GTF GRanges as input
#' predictNMD(new_query_gtf)
#'
#' ### Transcripts for analysis can be subsetted using logical conditions
#' predictNMD(new_query_gtf, transcript_id == "transcript1")
#' predictNMD(new_query_gtf, 
#' transcript_id %in% c("transcript1", "transcript3"))
#'
#'
#' ## Using exon and CDS GRangesLists as input
#' predictNMD(query_exons, cds = query_cds)
#' predictNMD(query_exons, cds = query_cds, transcript_id == "transcript3")
#'
#'
#' ## Using exon and CDS GRanges as input
#' predictNMD(query_exons[[3]], cds = query_cds[[3]])
#'
#'
#'
#' ## ---------------------------------------------------------------------
#' ## EXAMPLE USING TRANSCRIPT ANNOTATION
#' ## ---------------------------------------------------------------------
#' \donttest{
#' library(AnnotationHub)
#'
#' ## Retrieve GRCm38 trancript annotation
#' ah <- AnnotationHub()
#' GRCm38_gtf <- ah[["AH60127"]]
#'
#' ## Run tool on specific gene family
#' predictNMD(GRCm38_gtf, gene_name == "Ptbp1")
#' }
#'
predictNMD <- function(x, ..., cds = NULL, NMD_threshold = 50, 
                       progress_bar = TRUE) {

    # catch missing args
    mandargs <- c("x")
    passed <- names(as.list(match.call())[-1])
    if (any(!mandargs %in% passed)) {
        rlang::abort(paste(
            "missing values for",
            paste(setdiff(mandargs, passed), collapse = ", ")
        ))
    }
    # define global variable
    exonorder <- NULL

    # retrieve input object names
    argnames <- as.character(match.call())[-1]

    # check if exons is a gtf or both exons and cds are GR or GRlist
    if (is_gtf(x)) {
        exons <- sorteach(S4Vectors::split(x[x$type == "exon"], 
                                           ~transcript_id), exonorder)
        cds <- S4Vectors::split(x[x$type == "CDS"], ~transcript_id)
    } else if (all(is(x) %in% is(cds))) {
        if (is(x, "GRanges")) {
            exons <- sorteach(GenomicRanges::GRangesList("transcript" = x), 
                              exonorder)
            cds <- GenomicRanges::GRangesList("transcript" = cds)
        } else if (is(x, "GRangesList")) {
            exons <- sorteach(x, exonorder)
        } else {
            errorobj <- paste(unique(c(is(x)[1], is(cds)[2])), collapse = ", ")
            rlang::abort(sprintf(
                "input object types %s not supported", errorobj
            ))
        }
    } else {
        txtype <- is(x)[1]
        cdstype <- is(cds)[1]
        rlang::abort(sprintf(
            "`%s` is type %s but `%s` is type %s",
            argnames[2], cdstype, argnames[1], txtype
        ))
    }

    # catch unmatched seqlevels
    if (!has_consistentSeqlevels(exons, cds, verbose = FALSE)) {
        rlang::abort("exons and cds have inconsistent seqlevels")
    }

    # subset list for `which` and check if all exons have a cds entry
    totest <- .prepTotest(exons, cds, argnames, ...)

    # run NMD analysis and return result
    return(.testNMD(exons[totest], cds[totest], NMD_threshold, progress_bar))
}



.testNMD <- function(x, y, threshold, progress_bar) {

    # define global variables
    exonorder <- strand <- start1 <- end1 <- group <- NULL
    seqnames <- newstart <- newend <- width <- NULL
    strand...7 <- start...1 <- start...4 <- end...5 <- end...12 <- NULL
    start...11 <- group...1 <- group_name...2 <- seqnames...3 <- NULL

    out <- tibble::tibble(
        "transcript" = as.character(),
        "stop_to_lastEJ" = as.double(),
        "num_of_downEJs" = as.integer(),
        # "stop_to_downEJs" = as.character(),
        "3'UTR_length" = as.double(),
        "is_NMD" = as.logical(),
        "PTC_coord" = as.character()
    )

    toStopRange <- suppressMessages(
        dplyr::bind_cols(as.data.frame(range(x)), as.data.frame(range(y))) %>%
        dplyr::rowwise() %>%
        dplyr::mutate(newstart = ifelse(strand...7 == "-", 
                                        start...11, start...4)) %>%
        dplyr::mutate(newend = ifelse(
            strand...7 == "-", end...5, end...12)) %>%
        dplyr::select(group = group...1, group_name = group_name...2, 
                      seqnames = seqnames...3, start = newstart, 
                      end = newend, strand = strand...7) %>%
        GenomicRanges::makeGRangesFromDataFrame(keep.extra.columns = TRUE))

    toStopWidth <- sum(BiocGenerics::width(
        GenomicRanges::pintersect(x, toStopRange)))
    EJtoStop <- cumsum(BiocGenerics::width(x)) - toStopWidth
    
    StopCoord <- trimTranscripts(y, end = -3)
    StopCoord <- trimTranscripts(StopCoord, sum(BiocGenerics::width(y)))
    StopCoordString <- paste0(as.character(GenomeInfoDb::seqnames(unlist(StopCoord))), ":",
                              BiocGenerics::start(unlist(StopCoord)))
    
    # switch off progress_bar if requested
    if(!progress_bar) {
        pbo <- pbapply::pboptions(type = "none")
        on.exit(pbapply::pboptions(pbo), add = TRUE)
    }

    out <- dplyr::bind_rows(out, pbapply::pblapply(EJtoStop, function(x) {
        id <- ifelse(!is.null(names(x)), names(x)[1], "transcript")
        x <- sort(x, decreasing = TRUE)
        threeUTR <- x[1]
        dist_to_last <- x[2]
        is_NMD <- ifelse(dist_to_last > threshold, TRUE, FALSE)
        dist_to_eachEJ <- rev(x[-1][x[-1] > 0])



        return(tibble::tibble(
            "transcript" = id,
            "stop_to_lastEJ" = dist_to_last,
            "num_of_downEJs" = length(dist_to_eachEJ),
            # "stop_to_downEJs" = paste(dist_to_eachEJ, collapse = ","),
            "3'UTR_length" = threeUTR,
            "is_NMD" = is_NMD
        ))
    }) %>% dplyr::bind_rows() %>%
        tidyr::replace_na(list(is_NMD = FALSE)))
    
    out$PTC_coord <- ifelse(out$is_NMD, StopCoordString, out$PTC_coord)
    
    return(out)
}


.prepTotest <- function(x, y, arg, ...) {
    totest <- names(x) # prepare vector with names for testing
    if (!missing(...)) {
        totest <- tryCatch(
            names(filtereach(x, ...)),
            error = function(e) {
                rlang::abort(sprintf(
                    "Metadata in ... not found in `%s`",
                    arg[1]
                ))
            }
        )
        if (length(totest) == 0) {
            return(NULL)
        }
    }
    txwithcds <- intersect(totest, names(y)) # subset transcripts with cds info
    if (length(txwithcds) == 0) {
        rlang::abort("All transcripts have no CDS information")
    }
    if (length(txwithcds) < length(totest)) {
        totest <- txwithcds
    }
    rlang::inform(italic(sprintf(
        "    Predicting NMD sensitivities for %s mRNAs",
        length(totest)
    )))
    return(totest)
}

context("Test predictNMD functions")

data(query_exons)
data(query_cds)

test_that("Test .testNMD", {
  out <- .testNMD(query_exons[1], query_cds[1], 50, FALSE)
  expect_equal(out$is_NMD, FALSE)
  expect_equal(out$stop_to_lastEJ, -130)
  expect_equal(out$`3'UTR_length`, 1158)

  out <- .testNMD(query_exons[3], query_cds[3], 50, FALSE)
  expect_equal(out$is_NMD, TRUE)
  expect_equal(out$stop_to_lastEJ, 364)
  expect_equal(out$`3'UTR_length`, 644)
  # expect_equal(out$stop_to_downEJs, "69,286,364")
})

test_that("Test proper input arguments", {
  expect_error(predictNMD(query_exons[[1]], cds = query_cds))
  expect_error(predictNMD(query_exons[[1]], cds = q2rcovs))
  expect_error(predictNMD(q2r, cds = q2rcovs))
})

test_that("Test the structure of outputs", {
  out1 <- predictNMD(query_exons, cds = query_cds)
  expect_equal(names(out1), c(
    "transcript", "stop_to_lastEJ",
    "num_of_downEJs",
    "3'UTR_length", "is_NMD", "PTC_coord"
  ))
  expect_equal(nrow(out1), 4)
})

#' Imported GTF file containing 4 transcript entries of the same gene
#'
#' A dataset containing coordinates of transcript and exons from 4 transcripts 
#' of mouse Ptbp1. Transcript names and gene IDs have been modified to 
#' demonstrate de novo origin of GTF
#'
#' @format A GRanges object with 56 ranges and 3 metadata columns:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{transcript_id}{Name or ID given to transcripts}
#'   \item{gene_id}{Name or ID given to gene origin of transcripts}
#'   ...
#' }
#' @source \url{http://www.ensembl.org/}
#' @usage data(query_gtf)
"query_gtf"

#' Chromosome matched version of "query_gtf"
#'
#' query_gtf data which have been corrected for its seqlevels
#'
#' @format A GRanges object with 56 ranges and 3 metadata columns:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{transcript_id}{ID given to transcripts}
#'   \item{gene_id}{ID given to gene origin of transcripts}
#'   \item{gene_name}{Name given to gene origin of transcripts}
#'   ...
#' }
#' @usage data(chrom_matched_query_gtf)
"chrom_matched_query_gtf"

#' Seqlevels and gene_id matched query data
#'
#' query_gtf data which have been corrected for its seqlevels and gene_ids
#'
#' @format A GRanges object with 56 ranges and 6 metadata columns:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{transcript_id}{ID given to transcripts}
#'   \item{gene_id}{Matched gene_id}
#'   \item{old_gene_id}{Original gene_id}
#'   \item{match_level}{Level of matching performed}
#'   \item{gene_name}{Name of gene}
#'   ...
#' }
#' @usage data(matched_query_gtf)
"matched_query_gtf"

#' Query data containing CDS information
#'
#' matched_query_gtf data that has undergone buildCDS function and containing
#' CDS features
#'
#' @format A GRanges object with 105 ranges and 7 metadata columns:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{transcript_id}{ID given to transcripts}
#'   \item{gene_id}{Matched gene_id}
#'   \item{old_gene_id}{Original gene_id}
#'   \item{match_level}{Level of matching performed}
#'   \item{gene_name}{Name of gene}
#'   \item{phase}{Phase of open-reading frame}
#'   ...
#' }
#' @usage data(new_query_gtf)
"new_query_gtf"


#' GRangeList of exons from 4 transcripts entries from query_gtf
#'
#' A dataset containing coordinates of exons from 4 transcripts of
#' mouse Ptbp1. Transcript names and gene IDs have been modified
#'
#' @format A GRangesList object with 4 elements:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{transcript_id}{ID given to transcripts}
#'   \item{gene_id}{Matched gene_id}
#'   \item{old_gene_id}{Original gene_id}
#'   \item{match_level}{Level of matching performed}
#'   \item{gene_name}{Name of gene}
#'   ...
#' }
#' @usage data(query_exons)
"query_exons"




#' CDS from 4 transcripts entries of the same gene
#'
#' A dataset containing coordinates of CDS from 4 transcripts of
#' mouse Ptbp1. Transcript names and gene IDs have been modified
#'
#' @format A GRangesList object with 4 elements:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{transcript_id}{ID given to transcripts}
#'   \item{phase}{Phase of open-reading frame}
#'   \item{built_from}{Method by which CDS was built}
#'   ...
#' }
#' @usage data(query_cds)
"query_cds"

#' Imported GTF file containing 2 reference transcript entries of the same gene
#'
#' A dataset containing coordinates of transcript and exons from 2 reference
#' transcripts of mouse Ptbp1.
#'
#' @format A GRanges object with 64 ranges and 5 metadata columns:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{phase}{Phase of open-reading frame}
#'   \item{gene_id}{Matched gene_id}
#'   \item{gene_name}{Name of gene}
#'   \item{transcript_id}{ID given to transcripts}
#'   ...
#' }
#' @source \url{https://www.gencodegenes.org/}
#' @usage data(ref_gtf)
"ref_gtf"

#' Exons from 2 reference transcripts entries of the same gene
#'
#' A dataset containing coordinates of exons from 2 reference transcripts of
#' mouse Ptbp1.
#'
#' @format A GRangesList object with 2 elements:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{phase}{Phase of open-reading frame}
#'   \item{gene_id}{Matched gene_id}
#'   \item{gene_name}{Name of gene}
#'   \item{transcript_id}{ID given to transcripts}
#'   ...
#' }
#' @source \url{https://www.gencodegenes.org/}
#' @usage data(ref_exons)
"ref_exons"

#' CDS from 2 reference transcripts entries of the same gene
#'
#' A dataset containing coordinates of CDS from 2 reference transcripts of
#' mouse Ptbp1.
#'
#' @format A GRangesList object with 2 elements:
#' \describe{
#'   \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
#'   and its exons}
#'   \item{type}{Entry type; transcript or exon}
#'   \item{phase}{Phase of open-reading frame}
#'   \item{gene_id}{Matched gene_id}
#'   \item{gene_name}{Name of gene}
#'   \item{transcript_id}{ID given to transcripts}
#'   ...
#' }
#' @source \url{https://www.gencodegenes.org/}
#' @usage data(ref_cds)
"ref_cds"

#' Example output of predictDomains()
#'
#' Output dataframe from predictDomains() function.
#'
#' @format A data.frame with 14880 rows and 5 columns:
#' \describe{
#'   \item{transcript}{Transcript ID of protein-coding RNAs}
#'   \item{description}{Name of domain families}
#'   \item{eval}{E-value score}
#'   \item{begin}{Start position of domain in protein}
#'   \item{end}{End position of domain in protein}
#'   ...
#' }
#' @usage data(domains.out)
"domains.out"

#' Example output of predictDomains()
#'
#' Output dataframe from predictDomains() function. mRNAs from GENCODE
#' mouse annotation was predicted for putative domain families.
#'
#' @format A data.frame with 85780 rows and 5 columns:
#' \describe{
#'   \item{transcript}{Transcript ID of protein-coding RNAs}
#'   \item{description}{Name of domain families}
#'   \item{eval}{E-value score}
#'   \item{begin}{Start position of domain in protein}
#'   \item{end}{End position of domain in protein}
#'   ...
#' }
#' @usage data(domains.known)
"domains.known"

#' Test consistency of chromosome naming styles 
#' (aka seqlevels; e.g. "chr1" vs "1") across multiple objects
#'
#' @description
#' This function will determine if all input ranges objects have the 
#' same chromosome naming convention. Input objects can be GenomicRanges, 
#' BSgenome or Biostrings object with seqlevel information.
#'
#' @param ... Two or more objects with seqlevels information
#' @param verbose Whether to print out message
#'
#' @export
#' @author Fursham Hamid
#' @return Logical value as to whether all objects have consistent 
#' seqlevel styles
#'
#' @importFrom dplyr %>%
#' @importFrom IRanges %over%
#' @importFrom IRanges %within%
#' @importFrom data.table :=
#' @importFrom graphics frame
#' @importFrom methods as is new slot slotNames
#' @importFrom stats dist end start offset
#' @importFrom utils head tail
#' @importFrom rlang .data
#' @importFrom crayon italic
#'
#' @examples
#' ## ---------------------------------------------------------------------
#' ## EXAMPLE USING TOY DATASET
#' ## ---------------------------------------------------------------------
#' require(GenomicRanges)
#'
#' ## Create toy GRanges objects
#' gr1 <- GRanges("1", IRanges(start = c(1, 101), width = c(20, 20)), "+")
#' gr2 <- GRanges("chr1", IRanges(start = c(1, 101), width = c(20, 20)), "+")
#'
#' ## Test for seqlevels consistency
#' has_consistentSeqlevels(gr1, gr2)
#'
#' ## Input can be a Biostrings object with seqlevels information
#' x0 <- c("chr2" = "CTCACCAGTAT", "chr3" = "TGTCAGTCGA")
#' dna <- Biostrings::DNAStringSet(x0)
#'
#' ## Test for seqlevels consistency
#' has_consistentSeqlevels(gr1, dna)
#' has_consistentSeqlevels(gr2, dna)
has_consistentSeqlevels <- function(..., verbose = TRUE) {
    dots <- list(...)
    argnames <- as.character(match.call())[-1]

    if (length(dots) < 2) {
        rlang::abort("Insufficient input")
    }

    consistent <- c()
    for (i in seq(1, length(dots) - 1)) {
        for (j in seq(i + 1, length(dots))) {
            if (identical(dots[[i]], dots[[j]])) {
                next
            }
            test <- any(GenomeInfoDb::seqlevelsStyle(dots[[i]]) %in% 
                            GenomeInfoDb::seqlevelsStyle(dots[[j]]))
            testlevels <- sum(!GenomeInfoDb::seqlevels(dots[[i]]) %in% 
                                  GenomeInfoDb::seqlevels(dots[[j]]))
            consistent <- c(consistent, test)
            if (!test) {
                if(verbose){
                    rlang::warn(sprintf(
                        "Try running: %s <- matchChromosomes(%s, %s)", 
                        argnames[i], argnames[i], argnames[j]
                    )) 
                }
                
            } else if (testlevels > 0) {
                if(verbose){
                    rlang::warn(sprintf(
                        "%s seqlevel(s) in `%s` are not found in `%s`", 
                        testlevels, argnames[i], argnames[j]
                    ))
                }
                
            }
            break
        }
    }
    return(all(consistent))
}

## ----setup, echo=FALSE, cache=FALSE-------------------------------------------
## Global options  
options(max.print="100")  
knitr::opts_chunk$set(  
  collapse = TRUE,  
  comment = "#>")  
knitr::opts_knit$set(width=75)  

## ----silentload, include=FALSE------------------------------------------------
#Silent load all dependencies for vignette  
library(factR)  
library(AnnotationHub)  
library(Biostrings)  
library(BSgenome.Mmusculus.UCSC.mm10)  
library(GenomicFeatures)  
library(rtracklayer)  
library(tidyverse) 

## ----install.factR, eval = FALSE----------------------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
# BiocManager::install("factR")

## ----loadfactR----------------------------------------------------------------
library(factR)  

## ----importGTF----------------------------------------------------------------
gtf <- system.file("extdata", "sc_merged_sample.gtf.gz", package = "factR")
custom.gtf <- importGTF(gtf)  

## ----checktype----------------------------------------------------------------
class(custom.gtf)  

## ----headobj------------------------------------------------------------------
head(custom.gtf)  

## ----counttx------------------------------------------------------------------
length(unique(custom.gtf$transcript_id))  

## ----countcds-----------------------------------------------------------------
length(unique(custom.gtf[custom.gtf$type=="CDS"]$transcript_id))  

## ----plottranscripts, message=FALSE, warning=FALSE----------------------------
viewTranscripts(custom.gtf, "Zfr")  

## ----load.gencode, eval = TRUE------------------------------------------------
# query database for mouse gencode basic annotation  
library(AnnotationHub)  
ah <- AnnotationHub()  
query(ah, c('Mus musculus', 'gencode', 'gff'))
  
# Download full annotation  
ref.gtf <- ah[['AH49546']]  

## ----import.gencode, warning=FALSE--------------------------------------------
tmp <- tempfile()
download.file("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_M25/gencode.vM25.annotation.gtf.gz",  
              destfile = tmp)
ref.gtf <- importGTF(tmp) 

## ----matchgenemeta, warning=FALSE---------------------------------------------
# matching gene metadata  
custom_matched_1.gtf <- matchGeneInfo(custom.gtf, ref.gtf)  

## ----matchgenemeta2, warning=FALSE--------------------------------------------
# matching gene metadata  
custom_matched_2.gtf <- matchGeneInfo(custom.gtf, ref.gtf,   
                            primary_gene_id = "gene_id",   
                            secondary_gene_id = "ref_gene_id")  

## ----plottranscripts2---------------------------------------------------------
viewTranscripts(custom_matched_2.gtf, "Zfr")  

## ----subsettx, warning=FALSE--------------------------------------------------
custom_new.gtf <- subsetNewTranscripts(custom_matched_2.gtf, ref.gtf)  

viewTranscripts(custom_new.gtf,"Zfr")  

## ----subsettx2, warning=FALSE-------------------------------------------------
custom_new.gtf <- subsetNewTranscripts(custom_matched_2.gtf, ref.gtf, refine.by = "intron")  

viewTranscripts(custom_new.gtf, "Zfr")  

## ----genomeBSgenome, eval=FALSE-----------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("BSgenome.Mmusculus.UCSC.mm10")

## ----loadBSgenome-------------------------------------------------------------
library(BSgenome.Mmusculus.UCSC.mm10)
Mmusculus <- BSgenome.Mmusculus.UCSC.mm10

## ----genomeAhub---------------------------------------------------------------
library(AnnotationHub)   
ah <- AnnotationHub()  
query(ah, c("mm10","2bit"))   

## ----eval=FALSE---------------------------------------------------------------
# # Retrieve mouse genome
# Mmusculus <- ah[['AH14005']]

## ----downloadGencode, eval=FALSE----------------------------------------------
# tmp <- tempfile()
# download.file("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_M25/GRCm38.primary_assembly.genome.fa.gz",
#               tmp)
# Mmusculus <- importFASTA(paste0(tmp, "/GRCm38.primary_assembly.genome.fa.gz"))

## ----buildcds, warning=FALSE--------------------------------------------------
custom_new_CDS.gtf <- buildCDS(custom_new.gtf, ref.gtf, Mmusculus)  

## ----viewafterCDS-------------------------------------------------------------
viewTranscripts(custom_new_CDS.gtf, "Zfr")  

## ----viewafterCDSscale--------------------------------------------------------
viewTranscripts(custom_new_CDS.gtf, "Zfr", rescale_introns = TRUE)  

## ----viewrefCDS---------------------------------------------------------------
viewTranscripts(ref.gtf, "Zfr", rescale_introns = TRUE)  

## ----predictNMD1, warning=FALSE-----------------------------------------------
NMDprediction.out <- predictNMD(custom_new_CDS.gtf)  

head(NMDprediction.out)  

## ----predictNMD2--------------------------------------------------------------
NMDprediction.Zfr <- predictNMD(custom_new_CDS.gtf, gene_name == "Zfr") 

head(NMDprediction.Zfr)  

## ----predDomain2--------------------------------------------------------------
predictDomains(custom_new_CDS.gtf, Mmusculus, gene_name == "Zfr", progress_bar = FALSE)  

## ----predDomain3, eval = F----------------------------------------------------
# domains.Zfr <- predictDomains(custom_new_CDS.gtf, Mmusculus, gene_name == "Zfr", plot = TRUE, progress_bar = FALSE)

## ----predDomain1, eval=FALSE--------------------------------------------------
# domains.out <- predictDomains(custom_new_CDS.gtf, Mmusculus, progress_bar = FALSE)

## ----exportgtf, eval=FALSE----------------------------------------------------
# library(rtracklayer)
# export(custom_new_CDS.gtf, "Custom_new.gtf", format = "GTF")

## ----exporttable, eval=FALSE--------------------------------------------------
# write.table(NMDprediction.out, "Custom_new_NMD.txt", sep = "\t", row.names = FALSE, quote = FALSE)
# write.table(domains.out, "Custom_new_domains.txt", sep = "\t", row.names = FALSE, quote = FALSE)

## ----sessioninfo--------------------------------------------------------------
sessionInfo()  

#' Reference-guided construction of CDS on GTF object
#'
#' @description
#'
#' `buildCDS()` is designed to construct CDS information on transcripts from
#' query GTF object.
#'
#' @details
#' The `buildCDS()`function will first search for known reference mRNAs in
#' `query` and annotate its CDS information. For the remaining transcripts, 
#' `buildCDS()` will search for a putative translation start site using a 
#' database of annotated ATG codons from `ref`. Transcripts containing an 
#' open-reading frame will be assigned the newly-determined CDS information. 
#' 
#'
#' @param query
#' GRanges object containing query GTF data.
#' @param ref
#' GRanges object containing reference GTF data.
#' @param fasta
#' BSgenome or Biostrings object containing genomic sequence
#'
#' @return
#' GRanges object containing query exon entries and newly-constructed CDS
#' information
#'
#' @examples
#' # Load genome and datasets
#' library(BSgenome.Mmusculus.UCSC.mm10)
#' data(matched_query_gtf, ref_gtf)
#' 
#' # Build CDS
#' buildCDS(matched_query_gtf, ref_gtf, Mmusculus)
#' @export
#' @author Fursham Hamid
#'
buildCDS <- function(query, ref, fasta) {

    # catch missing args
    mandargs <- c("query", "ref", "fasta")
    passed <- names(as.list(match.call())[-1])
    if (any(!mandargs %in% passed)) {
        rlang::abort(paste(
            "missing values for",
            paste(setdiff(mandargs, passed), collapse = ", ")
        ))
    }

    # retrieve input object names
    argnames <- as.character(match.call())[-1]

    # carry out input checks
    .checkObjects(query, ref, fasta, argnames)

    # run core building function
    builtCDS <- .runbuildCDS(query, ref, fasta, argnames)

    # return appended CDS info
    return(c(query, builtCDS))
}

.checkObjects <- function(query, ref, fasta, argnames) {
    # check inputs are gtf
    if (any(!is_gtf(query, ref))) {
        rlang::abort(sprintf(
            "%s is/are not gtf GRanges",
            paste(argnames[seq_len(2)][!is_gtf(query, ref)], collapse = ",")
        ))
    }

    # check if ref have CDS info
    if (!"CDS" %in% S4Vectors::mcols(ref)$type) {
        rlang::abort(sprintf(
            "`%s` have missing CDS info", argnames[2]
        ))
    }

    # catch unmatched seqlevels
    if (!has_consistentSeqlevels(query, fasta, verbose = FALSE)) {
        rlang::abort(sprintf(
            "`%s` and `%s` has unmatched seqlevel styles. 
Try running: %s <- matchChromosomes(%s, %s)",
            argnames[1], argnames[3], argnames[1], argnames[1], argnames[3]
        ))
    }
    if (!has_consistentSeqlevels(ref, fasta, verbose = FALSE)) {
        rlang::abort(sprintf(
            "`%s` and `%s` has unmatched seqlevel styles. 
Try running: %s <- matchChromosomes(%s, %s)",
            argnames[2], argnames[3], argnames[2], argnames[2], argnames[3]
        ))
    }

}

.runbuildCDS <- function(query, ref, fasta, argnames) {
    transcript_id <- gene_id <- gene_name <- type <- width <- strand <- NULL
    phase <- tailphase <- coverage <- group <- seanames <- seqnames <- NULL
    group_name <- NULL

    # Add gene_name column if absent
    if (!"gene_name" %in% names(S4Vectors::mcols(query))) {
        query$gene_name <- query$gene_id
    }

    # extract important information
    totaltx <- query$transcript_id %>%
        unique() %>%
        length()
    genelist <- query %>%
        as.data.frame() %>%
        dplyr::select(transcript_id, gene_id, gene_name) %>%
        dplyr::distinct(transcript_id, .keep_all = TRUE)
    query <- query[BiocGenerics::strand(query) != "*"]

    # Create lists of cds and exons
    rlang::inform(italic("    Searching for reference mRNAs in query"))
    query_exons <- S4Vectors::split(query[query$type == "exon"], ~transcript_id)
    ref_cds <- S4Vectors::split(ref[ref$type == "CDS"], ~transcript_id)
    ref_exons <- S4Vectors::split(ref[ref$type == "exon"], ~transcript_id)

    # run pairing of query to reference and unpack object
    q2r_output <- .pairq2r(query_exons, ref_cds, ref_exons, ref, fasta)
    q2r <- q2r_output[[1]]
    codons_gr <- q2r_output[[2]]

    # split q2r pairs into full covs and the rest
    fullcovs <- q2r %>%
        dplyr::filter(coverage == 1)
    q2r <- dplyr::setdiff(q2r, fullcovs)

    # prepare outputCDS for full coverages
    if (nrow(fullcovs) > 1) {
        fulloutCDS <- ref_cds %>%
            as.data.frame() %>%
            dplyr::filter(group_name %in% fullcovs[[3]]) %>%
            dplyr::select(group:strand) %>%
            dplyr::mutate(type = "CDS") %>%
            dplyr::left_join(fullcovs[, c(1, 3)],
                by = c("group_name" = "ref_transcript_id")
            ) %>%
            dplyr::group_by(transcript_id) %>%
            dplyr::arrange(ifelse(strand == "-", dplyr::desc(start), start)) %>%
            dplyr::mutate(phase = rev(cumsum(rev(width) %% 3) %% 3)) %>%
            dplyr::ungroup() %>%
            dplyr::select(seqnames:phase)
    } else {
        fulloutCDS <- NULL
    }

    # prepare vector for remaining comparisons
    order_query <- query_exons[q2r$transcript_id]
    order_ref <- codons_gr[q2r$ref_transcript_index]

    # run .getCDS function for remaining transcripts
    if (length(order_query) > 0) {
        restoutCDS <- .getCDS(order_query, order_ref, fasta)
        rlang::inform(italic(sprintf("    %s new CDSs constructed",
                              length(unique(restoutCDS$transcript_id)))))
    } else {
        restoutCDS <- NULL
    }

    # combine all CDSs and print out stats
    outCDS <- dplyr::bind_rows(fulloutCDS, restoutCDS)
    if (nrow(outCDS) > 0) {
        outCDS <- outCDS %>%
            dplyr::arrange(transcript_id, ifelse(strand == "-",
                dplyr::desc(start), start
            )) %>%
            dplyr::left_join(genelist, by = "transcript_id")

        successtx <- length(unique(outCDS$transcript_id))
        rlang::inform(italic(sprintf(
            paste0("\n    Summary: Out of %s transcripts in `%s`,\n", 
                   "    %s transcript CDSs were built"),
            totaltx, argnames[1], successtx
        )))
        return(GenomicRanges::makeGRangesFromDataFrame(outCDS,
            keep.extra.columns = TRUE
        ))
    } else {
        rlang::inform(italic(sprintf(
            paste0("\n    Summary: Out of %s transcripts in `%s`,\n", 
                   "    no CDSs were built"),
            totaltx, argnames[1]
        )))
        return(NULL)
    }
}

.pairq2r <- function(query_exons, ref_cds, ref_exons, ref, fasta) {
    ref_transcript_id <- strand <- transcript_id <- coverage <- NULL
    ref_transcript_index <- type <- width <- phase <- tailphase <- NULL
    group <- resize <- width <- NULL

    # search for exact query and ref matches
    fulloverlap <-  GenomicRanges::findOverlaps(query_exons, ref_exons,
                                        type = "equal", select = "first")

    # prepare dataframe of query to reference pairs
    q2r <- data.frame(
        "transcript_id" = names(query_exons),
        "ref_transcript_index" = fulloverlap,
        stringsAsFactors = FALSE
    ) %>%
        dplyr::filter(!is.na(ref_transcript_index)) %>%
        dplyr::mutate(ref_transcript_id = 
                          names(ref_exons[ref_transcript_index])) %>%
        dplyr::filter(ref_transcript_id %in% names(ref_cds)) %>%
        dplyr::mutate(coverage = 1)
    
    # report known mRNAs
    if (nrow(q2r) > 0) {
        rlang::inform(italic(sprintf(
            "    %s reference mRNAs found and its CDS were assigned",
                              nrow(q2r))))
    } else {
        rlang::inform(italic("    No reference mRNAs found"))
    }
    

    # search for first ATG overlap for non-exact transcripts
    if (nrow(q2r) < length(query_exons)) {
        rlang::inform(italic("    Building database of annotated ATG codons"))
        nonexact <- query_exons[!names(query_exons) %in% q2r$transcript_id]
        subsetRef <- IRanges::subsetByOverlaps(ref, nonexact)

        # prepare a list of exons trimmed by codon triplets
        codons_gr <- subsetRef %>%
            as.data.frame() %>%
            dplyr::filter(type == "CDS") %>%
            dplyr::group_by(transcript_id) %>%
            dplyr::arrange(ifelse(strand == "-", dplyr::desc(start), start)) %>%
            dplyr::mutate(tailphase = (cumsum(width) %% 3) %% 3) %>%
            dplyr::mutate(order = dplyr::row_number()) %>%
            dplyr::ungroup() %>%
            dplyr::mutate(start = ifelse(strand == "+", 
                                         start + phase, 
                                         start + tailphase)) %>%
            dplyr::mutate(end = ifelse(strand == "-", 
                                       end - phase, 
                                       end - tailphase)) %>%
            dplyr::filter(end > start) %>%
            dplyr::group_by(strand) %>%
            dplyr::arrange(order, ifelse(strand == "-", 
                                         dplyr::desc(end), 
                                         start)) %>%
            GenomicRanges::makeGRangesFromDataFrame() %>%
            unique()
        
        # shortlist trimmed exons which fully overlap query transcripts
        codons_gr <-  IRanges::subsetByOverlaps(codons_gr, nonexact, 
                                                type = "within")
        codons_gr <- codons_gr[as.character(GenomeInfoDb::seqnames(codons_gr)) 
                               %in% GenomeInfoDb::seqlevels(fasta)]

        # further trim exons to only retain ATG codon
        codons_seq <-  suppressWarnings(BSgenome::getSeq(fasta, codons_gr))

        
        startMatch <- Biostrings::vmatchPattern("ATG", codons_seq) %>%
            as.data.frame() %>%
            dplyr::group_by(group) %>%
            dplyr::filter(end %% 3 == 0) %>%
            dplyr::mutate(start = start - 1)
        codons_gr <- codons_gr[startMatch$group]
        codons_gr <- GenomicRanges::resize(codons_gr, 
                    width = BiocGenerics::width(codons_gr) - startMatch$start, 
                    fix = "end")
        codons_gr <- GenomicRanges::resize(codons_gr, width = 3, fix = "start")

        # select up-stream most ATG codon for remaining transcripts
        rlang::inform(italic(paste0("    Selecting best ATG start codon for remaining ",
        "transcripts and determining open-reading frame")))
        firstATGoverlap <-  GenomicRanges::findOverlaps(nonexact, 
                                                       codons_gr, 
                                                       minoverlap = 3, 
                                                       select = "first")
        
        # Update q2r with selected ATG start
        firstATGq2r <- data.frame(
            "transcript_id" = names(nonexact),
            "ref_transcript_index" = firstATGoverlap,
            stringsAsFactors = FALSE
        ) %>%
            dplyr::filter(!is.na(ref_transcript_index)) %>%
            dplyr::mutate(coverage = 2)
        q2r <- dplyr::bind_rows(q2r, firstATGq2r)
    } else {
        codons_gr <- NULL
    }

    return(list(q2r, codons_gr))
}

.getCDS <- function(order_query, order_ref, fasta) {
    strand <- start1 <- end1 <- group <- seqnames <- newstart <- newend <- NULL
    stoppos <- width <- seqnames <- strand <- type <- transcript_id  <- NULL
    newstrand <- exonorder <- phase <- NULL
    strand...7 <- start...4 <- start...9 <- end...10 <- end...5 <- NULL
    group_name <- seqnames...3 <- NULL

    # get range from ATG to end of transcript
    startToend <- suppressMessages(
        dplyr::bind_cols(as.data.frame(range(order_query)), 
                         as.data.frame(order_ref)) %>%
            dplyr::rowwise() %>%
            dplyr::mutate(newstart = list(ifelse(strand...7 == "-", 
                                                 start...4, start...9))) %>%
            dplyr::mutate(newend = list(ifelse(strand...7 == "-", 
                                               end...10, end...5))) %>%
            dplyr::ungroup() %>%
            dplyr::mutate(strand = as.character(strand...7)) %>%
            dplyr::mutate(newstrand = strand) %>%
            dplyr::mutate(newstrand = ifelse(strand == "-" & newend > end...5, 
                                             "+", newstrand)) %>%
            dplyr::mutate(newstrand = ifelse(
                strand != "-" & newstart < start...4, "-", newstrand)) %>%
            dplyr::select(group, group_name, seqnames = seqnames...3, 
                          start = newstart, end = newend, 
                          strand = newstrand) %>%
            GenomicRanges::makeGRangesFromDataFrame(keep.extra.columns = TRUE))

    # get exon coordinates and sequence from ATG to end of transcript
    startToendexons <-  GenomicRanges::pintersect(order_query, 
                                                 startToend, 
                                                 drop.nohit.ranges = TRUE) %>%
        sorteach(exonorder)
    seq <- GenomicFeatures::extractTranscriptSeqs(fasta, startToendexons)

    # search for in-frame stop codon and return a df of 
    # its position in startToendexons
    CDSstop <- lapply(c("TAG", "TGA", "TAA"), function(x) {
        a <- Biostrings::vmatchPattern(x, seq)
        as.data.frame(a)
    }) %>%
        dplyr::bind_rows() %>%
        dplyr::group_by(group) %>%
        dplyr::filter(end %% 3 == 0) %>%
        dplyr::arrange(start) %>%
        dplyr::select(group, start) %>%
        dplyr::distinct(group, .keep_all = TRUE) %>%
        dplyr::mutate(start = start - 1)

    # prepare df with 3UTR length (if any) for each transcript
    stopdf <- tibble::tibble(group = seq_len(length(seq)), 
                             width = BiocGenerics::width(seq)) %>%
        dplyr::left_join(CDSstop, by = "group") %>%
        dplyr::mutate(threeUTR = ifelse(!is.na(start), (width - start), width))

    # resize 3' end of transcript to just before stop codon and prepare output
    outCDS <- trimTranscripts(startToendexons, start = 0, end = stopdf$threeUTR)
    outCDS <- outCDS %>%
        as.data.frame() %>%
        dplyr::mutate(type = "CDS") %>%
        dplyr::group_by(group) %>%
        dplyr::mutate(phase = rev(cumsum(rev(width) %% 3) %% 3)) %>%
        dplyr::ungroup() %>%
        dplyr::select(seqnames, start, end, strand, type, transcript_id, phase)


    if (nrow(outCDS) == 0) {
        return(NULL)
    } else {
        return(outCDS)
    }
}

context("Test buildCDS function")

data(query_gtf)
data(query_cds)
data(matched_query_gtf)
data(new_query_gtf)
data(ref_gtf)
data(ref_cds)

library(BSgenome.Mmusculus.UCSC.mm10)

test_that("Test buildCDS robustness", {
  expect_error(buildCDS(query_gtf, ref_cds, Mmusculus))
  expect_error(buildCDS(query_gtf, query_gtf, Mmusculus))
  expect_error(buildCDS(query_gtf, ref_gtf, Mmusculus))
})

test_that("Test .runbuildCDS", {
  out <- .runbuildCDS(matched_query_gtf, ref_gtf, Mmusculus, "test")
  expect_equal(is(out, "GRanges"), TRUE)
  expect_equal(length(out), 49)
  expect_equal(BiocGenerics::start(out), BiocGenerics::start(unlist(query_cds)))
})

#' Shortlist GTF GRanges object for new transcripts
#'
#' @description
#' `subsetNewTranscripts()` will retain transcripts in `query` that are distinct
#' from those in `ref`
#'
#' @details
#' `subsetNewTranscripts()` will compare query and reference GTF GRanges and 
#' return query transcripts with different exon structures from reference 
#' transcripts. Transcriptome assemblers may sometime extend 5' and 3' ends 
#' of known transcripts based on experimental data. These annotated transcripts 
#' can be removed by inputting "intron" to the refine.by argument. This will 
#' further compare and remove transcripts of identical intron structures. 
#' Alternatively, transcripts with unique CDS coordinates can be selected by 
#' typing "cds" to the refine.by argument.
#'
#'
#' @param query
#' GRanges object containing query GTF data.
#' @param ref
#' GRanges object containing reference GTF data.
#' @param refine.by
#' Whether to refine the selection process by removing query transcripts with
#'  similar introns or CDS structure to reference. Default input is "none", and 
#'  can be changed to "intron" or "cds" respectively.
#'
#' @return
#' Filtered GRanges GTF object
#'
#' @export
#'
#' @author Fursham Hamid
#' @examples
#' # Load dataset
#' data(matched_query_gtf, ref_gtf)
#' 
#' # shortlist new transcripts
#' subsetNewTranscripts(matched_query_gtf, ref_gtf)
subsetNewTranscripts <- function(query, ref, 
                                 refine.by = c("none", "intron", "cds")) {

    # catch missing args
    mandargs <- c("query", "ref")
    passed <- names(as.list(match.call())[-1])
    if (any(!mandargs %in% passed)) {
        rlang::abort(paste(
            "missing values for",
            paste(setdiff(mandargs, passed), collapse = ", ")
        ))
    }

    # retrieve input object names
    argnames <- as.character(match.call())[-1]

    # carry out input checks
    .checkinputs(query, ref, argnames)

    # run subsetting and return new transcripts
    return(.subsetTranscripts(query, ref, refine.by[1]))
}

.checkinputs <- function(query, ref, argnames) {
    # check inputs are gtf
    if (any(!is_gtf(query, ref))) {
        rlang::abort(sprintf(
            "%s is/are not gtf GRanges",
            paste(argnames[seq_len(2)][!is_gtf(query, ref)], collapse = ",")
        ))
    }


    # catch unmatched seqlevels
    if (!has_consistentSeqlevels(query, ref, verbose = FALSE)) {
        rlang::abort(sprintf(
            "`%s` and `%s` has unmatched seqlevel styles. 
Try running: %s <- matchChromosomes(%s, %s)",
            argnames[1], argnames[2], argnames[1], argnames[1], argnames[2]
        ))
    } else {
        outmsg <- has_consistentSeqlevels(query, ref)
    }
}

.subsetTranscripts <- function(query, ref, by) {

    # Filter transcripts by identical exon structure:
    # create exons by transcripts
    rlang::inform("Removing transcripts with exact exon coordinates")
    query_exons <- S4Vectors::split(query[query$type == "exon"], ~transcript_id)
    ref_exons <- S4Vectors::split(ref[ref$type == "exon"], ~transcript_id)

    # search for exact query and ref matches
    fulloverlap <- GenomicRanges::findOverlaps(query_exons, ref_exons,
        type = "equal", select = "first"
    )

    # return transcripts that are not found in reference
    query <- query[!query$transcript_id %in% 
                       names(query_exons)[!is.na(fulloverlap)]]

    # Refine list By identical introns:
    if (by == "intron") {
        rlang::inform("Removing transcripts with exact intron coordinates")
        # create exons by transcripts
        query_exons <- S4Vectors::split(
            query[query$type == "exon"], ~transcript_id)
        ref_exons <- S4Vectors::split(ref[ref$type == "exon"], ~transcript_id)

        # convert exon coord to intron coord
        query_introns <- GenomicRanges::psetdiff(
            BiocGenerics::unlist(range(query_exons)), query_exons)
        ref_introns <- GenomicRanges::psetdiff(
            BiocGenerics::unlist(range(ref_exons)), ref_exons)

        # search for exact query and ref matches
        fulloverlap_intron <- GenomicRanges::findOverlaps(query_introns, 
            ref_introns, type = "equal", select = "first")
        # return transcripts that are not found in reference
        query <- query[!query$transcript_id %in% 
                           names(query_exons)[!is.na(fulloverlap_intron)]]
    }

    # Refine list By identical CDS:
    else if (by == "cds") {
        rlang::inform("Removing transcripts with exact CDS coordinates")
        # create CDS by transcripts
        query_CDS <- S4Vectors::split(query[query$type == "CDS"], 
                                      ~transcript_id)
        ref_CDS <- S4Vectors::split(ref[ref$type == "CDS"], ~transcript_id)

        # search for exact query and ref matches
        fullCDSoverlap <- GenomicRanges::findOverlaps(query_CDS, ref_CDS,
            type = "equal", select = "first"
        )

        # return coding transcripts that are not found in reference
        query <- query[query$transcript_id %in% names(query_CDS)]
        query <- query[!query$transcript_id %in% 
                           names(query_CDS)[!is.na(fullCDSoverlap)]]
    }
    return(query)
}

context("Test subset function")

data(query_gtf)
data(matched_query_gtf)
data(new_query_gtf)
data(ref_gtf)
data(ref_cds)

test_that("Test subset robustness", {
  expect_error(subsetNewTranscripts(query_gtf, ref_cds))
  expect_error(buildCDS(query_gtf))
})

test_that("Test .subsetTranscripts", {
  out <- .subsetTranscripts(matched_query_gtf, ref_gtf, "exon")
  expect_equal(is(out, "GRanges"), TRUE)
  expect_equal(length(out), 27)
  expect_equal(unique(out$transcript_id), c("transcript3", "transcript4"))
})

test_that("Test .subsetTranscripts by.name", {
  out <- .subsetTranscripts(matched_query_gtf, ref_gtf, "intron")
  expect_equal(length(out), 27)
  expect_equal(unique(out$transcript_id), c("transcript3", "transcript4"))
})

test_that("Test .subsetTranscripts by.CDS", {
  out <- .subsetTranscripts(new_query_gtf, ref_gtf, "cds")
  expect_equal(length(out), 49)
  expect_equal(unique(out$transcript_id), c("transcript3", "transcript4"))
})

#usr/bin/bash

# Section 3.2.3: Retrieve data
mkdir FASTQ_sc
while IFS=$'\t' read -r NAME CLASS LINK CLASSNUM;do
 	wget $LINK -P FASTQ_sc
 	tar -xvf "FASTQ_sc/$NAME.fastq.tar" -C FASTQ_sc
 	rm FASTQ_sc/$NAME.fastq.tar
done < sc_fastq_curated.txt

# Section 3.2.4: Merge FASTQ by apparent cell type
# Create arrays to store filenames and group names
declare -A fastqArray
declare -A fastqNames

while IFS=$'\t' read -r NAME CLASS LINK;do
    fastqArray["$CLASS.1"]="${fastqArray["$CLASS.1"]} FASTQ_sc/${NAME}_R1.fastq.gz"
    fastqArray["$CLASS.2"]="${fastqArray["$CLASS.2"]} FASTQ_sc/${NAME}_R2.fastq.gz"
    fastqNames["$CLASS.1"]=${CLASS}_R1
    fastqNames["$CLASS.2"]=${CLASS}_R2
done < sc_fastq_curated.txt

# Loop groups and concatenate FASTQ files
for n in Glutamatergic GABAergic Endothelial Astrocyte;do
	cat ${fastqArray["$n.1"]} > FASTQ_sc/${fastqNames["$n.1"]}.fastq.gz
	cat ${fastqArray["$n.2"]} > FASTQ_sc/${fastqNames["$n.2"]}.fastq.gz
done

# Section 3.2.5: Download index
if [ ! -d "mm10" ]; then
	wget https://genome-idx.s3.amazonaws.com/hisat/mm10_genome.tar.gz
	tar -xf "mm10_genome.tar.gz"
	rm mm10_genome.tar.gz
fi

# Section 3.2.6: Align reads
cores=`nproc`
mkdir Hisat2_SAMs_sc
for fastq in Glutamatergic GABAergic Endothelial Astrocyte;do
	hisat2 -p $cores --dta -x mm10/genome -1 FASTQ_sc/"$fastq"_R1.fastq.gz -2 FASTQ_sc/"$fastq"_R2.fastq.gz -S Hisat2_SAMs_sc/$fastq.sam
done

# Section 3.2.7: Convert SAM to BAM
mkdir Hisat2_sorted_BAMs_sc
for file in Glutamatergic GABAergic Endothelial Astrocyte; do
	samtools view -@ $cores -Su Hisat2_SAMs_sc/$file.sam | samtools sort -@ $cores -o Hisat2_sorted_BAMs_sc/$file.bam
done

# Section 3.2.8: Download reference annotation
if [ ! -f "gencode.vM25.annotation.gtf" ]; then
	wget ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_M25/gencode.vM25.annotation.gtf.gz
	gzip -d gencode.vM25.annotation.gtf.gz
fi

# Section 3.2.9: Assemble transcriptome
mkdir Stringtie_gtf_sc
for file in Glutamatergic GABAergic Endothelial Astrocyte; do
	stringtie Hisat2_sorted_BAMs_sc/$file.bam -p $cores -o Stringtie_gtf_sc/$file.gtf -G gencode.vM25.annotation.gtf
done

# Section 3.2.10: Merge transcriptome and compress
stringtie --merge -G gencode.vM25.annotation.gtf Stringtie_gtf_sc/Glutamatergic.gtf Stringtie_gtf_sc/GABAergic.gtf Stringtie_gtf_sc/Endothelial.gtf Stringtie_gtf_sc/Astrocyte.gtf | gzip > sc_merged.gtf.gz 

---  
title: "Using factR"  
author: "Fursham Hamid"  
date: "`r Sys.Date()`"  
output:  
  rmarkdown::html_document:
    highlight: kate
    toc: true
    toc_depth: 3
    number_sections: true
vignette: >  
  %\VignetteIndexEntry{factR}  
  %\VignetteEngine{knitr::rmarkdown}  
bibliography: references.bib 
---  
  
```{r setup, echo=FALSE, cache=FALSE}  
## Global options  
options(max.print="100")  
knitr::opts_chunk$set(  
  collapse = TRUE,  
  comment = "#>")  
knitr::opts_knit$set(width=75)  
```  
  
  
```{r silentload, include=FALSE}  
#Silent load all dependencies for vignette  
library(factR)  
library(AnnotationHub)  
library(Biostrings)  
library(BSgenome.Mmusculus.UCSC.mm10)  
library(GenomicFeatures)  
library(rtracklayer)  
library(tidyverse) 
```  
  
# Introduction  
Many eukaryotic genes give rise to multiple RNA isoforms, increasing the 
protein-coding capacity of the genome and extending the range of 
post-transcriptional regulation possibilities. High-throughput sequencing is 
often used to deduce repertoires of transcripts expressed in specific 
biological samples by aligning the data to genomic sequences and assembling 
the alignments into transcript architectures. This typically outputs Gene 
Transfer Format (GTF) files describing newly identified transcripts as sets of 
exonic coordinates, but lacking the information about their coding sequences 
(CDSs; also known as ORFs) and possible biological functions.   
  
To this end, we developed a package for functional annotation of 
custom-assembled transcriptomes in R (*factR*). *factR* predicts CDSs for novel 
RNA isoforms using a reference-guided process and then determines domain 
organisation of the protein products and possible susceptibility of 
transcripts to nonsense-mediated decay (NMD; a pathway destabilizing mRNAs 
with premature translation termination codons). *factR* also provides 
supporting tools for matching new transcripts to "official" gene IDs, 
visualizing transcript architectures and annotating alternatively 
spliced segments.  
  
  
# Getting started  
  
## Installing *factR*  
To install *factR*, enter the following commands in your R environment:  
```{r install.factR, eval = FALSE}  
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("factR")
```  
  
## Materials needed  
  
### Custom-assembled transcriptome  
  
*factR* requires a custom transcriptome file in the GTF format as an input, 
and we provide the following three sample custom transcriptome files that can 
be used to test *factR* tools:
  
1. **bulk_merged_sample.gtf.gz** assembled using the HISAT2-StringtTie2 pipeline 
[@Pertea2016] from bulk RNA-seq data for mouse embryonic stem cells treated 
with the NMD inhibitor cycloheximide (CHX) or left untreated as a control.   
2. **sc_merged_sample.gtf.gz** assembled using the HISAT2-StringtTie2 pipeline from 
single-cell RNA-seq data for glutamatergic neurons, GABAergic neurons, 
astrocytes or endothelial cells from the mouse visual cortex [@Tasic2018]. 
A simplified version of this GTF containing the first 500 genes on chr15 is
available as part of *factR*.
3. **lr_merged_sample.gtf.gz** assembled using minimap2 [@Li2018] and StringtTie2 
[@Kovaka2019] from brain-specific long-read Oxford Nanopore RNA sequencing 
data [@Sessegolo2019].  
  
Method to download the above GTF files is described in the 
["Importing and inspecting GTF data"](#importing-and-inspecting-gtf-data) 
section below.  
Users may alternatively prepare their own GTF files making sure that these 
contain both **gene_id** and **transcript_id** attributes.   
<!-- *In the future, add how to build custom GTF files* -->  
  
### Reference transcriptome  
  
Several *factR* functions require reference transcriptome files (GTF or GFF3) 
as a guide. Such files can be accessed from within the R environment using e.g. 
the R package *AnnotationHub* or downloaded from an external database such as 
GENCODE or Ensembl. Both possibilities are described in the 
["Updating gene info"](#updating-gene-info) section below.  
  
  
### Genome  
  
*factR* needs genomic DNA sequence to predict CDSs. Users may obtain genome 
files using e.g. *BSgenome* or *AnnotationHub* or download them from an 
external database such as GENCODE or Ensembl. We describe this in more detail 
in the ["Constructing CDS information"](#constructing-cds-information) 
section below.  
  
# Using *factR*  
Load *factR* to the R environment as follows:  

```{r loadfactR}  
library(factR)  
```  
  
## Importing and inspecting GTF data  
  
*factR* handles transcriptome information in the form of *GenomicRanges* 
objects containing genomic interval data and relevant metadata. To create such 
an object from a GTF file, we use the `importGTF` function:  
```{r importGTF}  
gtf <- system.file("extdata", "sc_merged_sample.gtf.gz", package = "factR")
custom.gtf <- importGTF(gtf)  
```  
<!-- This should import sc_merged_sample.gtf.gz, and we will use this input in the  -->
<!-- walk-through below. To try bulk_merged.gtf.gz or lr_merged.gtf.gz, simply  -->
<!-- change "sc" to "bulk" or "lr" in the selected.data variable. Users may import  -->
<!-- their own GTF file by specifying the path to such file in the `importGTF`  -->
<!-- function.  -->
  
The imported GTF file is stored as a *GenomicRanges* object.  
```{r checktype}  
class(custom.gtf)  
```  
  
Contents of the object can be examined using `head`:  
```{r headobj}  
head(custom.gtf)  
```  
  
In addition to genomic coordinates (seqnames and ranges), a typical GTF file 
contains metadata describing the feature type (e.g. transcript or exon), 
transcript IDs and some information on their parental genes.    
  
Use the following command to calculate the total number of transcripts in the
input transcriptome:  
```{r counttx}  
length(unique(custom.gtf$transcript_id))  
```  
  
Note that none of the transcripts in the custom.gtf object contain CDS 
information:  
```{r countcds}  
length(unique(custom.gtf[custom.gtf$type=="CDS"]$transcript_id))  
```  
  
## Plotting transcript structures  
Users may visualize specific sets of transcripts using `viewTranscripts`. 
For example, the following will plot transcripts from the *Zfr* gene encoding a 
conserved zinc finger-containing RNA-binding protein with known neuronal
functions :  
```{r plottranscripts, message=FALSE, warning=FALSE}  
viewTranscripts(custom.gtf, "Zfr")  
```  
  
StringTie2, a popular transcript assembler used to generate our custom GTF, 
typically assigns arbitrary names to newly identified transcripts 
(e.g. "MSTRG.x.y") and uses the same prefix for their gene IDs 
(e.g. "MSTRG.x"). Incidentally, this is why the output above contains 10 
previously known *Zfr* transcripts but lacks any novel entries.   
  
## Updating gene info  
*factR* can update gene metadata in custom transcriptome objects using a 
reference annotation as guide. Below, we describe two alternative ways to 
obtain mouse reference transcriptome data from GENCODE.  
  
1. Using *AnnotationHub* package  
```{r load.gencode, eval = TRUE}  
# query database for mouse gencode basic annotation  
library(AnnotationHub)  
ah <- AnnotationHub()  
query(ah, c('Mus musculus', 'gencode', 'gff'))
  
# Download full annotation  
ref.gtf <- ah[['AH49546']]  
```  
  
2. Downloading from a GENCODE database (ref.gtf generated from this method 
will be used for the remaining of the workflow) 
```{r import.gencode, warning=FALSE}  
tmp <- tempfile()
download.file("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_M25/gencode.vM25.annotation.gtf.gz",  
              destfile = tmp)
ref.gtf <- importGTF(tmp) 
```  
  
When choosing a reference, users should consider using one with the same 
chromosome naming style (e.g. "chr1" or "1"). Alternatively, the styles can be 
matched using the  `matchChromosomes` function (see `help(matchChromosomes)` 
for more detail).    
  
Once the ref.gtf object is ready, novel transcripts in custom.gtf can be 
assigned to "official" gene IDs, whenever possible, using `matchGeneInfo`. By 
default, this function matches the query (custom.gtf) to the reference (ref.gtf) 
by finding overlapping coordinates:  
```{r matchgenemeta, warning=FALSE}  
# matching gene metadata  
custom_matched_1.gtf <- matchGeneInfo(custom.gtf, ref.gtf)  
```  
  
To tune the performance of `matchGeneInfo`, we provide additional arguments 
specifying the name of columns containing "primary" and potentially "secondary" 
gene IDs from the query (custom.gtf). For further information, 
see `help(matchGeneInfo)`.  
```{r matchgenemeta2, warning=FALSE}  
# matching gene metadata  
custom_matched_2.gtf <- matchGeneInfo(custom.gtf, ref.gtf,   
                            primary_gene_id = "gene_id",   
                            secondary_gene_id = "ref_gene_id")  
```  
  
Note that custom.gtf updated by `matchGeneInfo` now contains 10 known and 7 
newly *Zfr* assembled transcripts:  
```{r plottranscripts2}  
viewTranscripts(custom_matched_2.gtf, "Zfr")  
```  
  
## Shortlisting novel transcripts  
As seen in the above example, custom transcriptomes typically combine both 
new and previously annotated transcripts. To select only newly predicted 
transcripts, run the following:  
```{r subsettx, warning=FALSE}  
custom_new.gtf <- subsetNewTranscripts(custom_matched_2.gtf, ref.gtf)  

viewTranscripts(custom_new.gtf,"Zfr")  
```  
  
This will subset custom.gtf transcripts with distinct exonic coordinates 
compared to ref.gtf and will store these transcripts in the custom_new.gtf 
object. Some custom-built transcripts may differ from their reference 
counterparts by having different start or/and end coordinates, with otherwise 
similar exon-intron structure. To shortlist novel transcripts with distinct 
intronic coordinates only, simply set the "refine.by" argument to "intron":  
```{r subsettx2, warning=FALSE}  
custom_new.gtf <- subsetNewTranscripts(custom_matched_2.gtf, ref.gtf, refine.by = "intron")  

viewTranscripts(custom_new.gtf, "Zfr")  
```  
  
We will use the custom_new.gtf object in the rest of the workflow.  
  
## Constructing CDS information  
Functional annotation of newly assembled transcripts in *factR* begins by 
deducing their protein-coding sequences (CDSs). To search for putative CDSs, 
*factR* requires a genome sequence file, which can be obtained using R packages 
or downloaded from online databases (e.g. UCSC, GENCODE or Ensembl). Three 
alternative ways to retrieve mouse genomic sequence are described below.    
  
1. Using *BSgenome*  (Mmusculus generated from this method will be used for 
the remaining of the workflow)
This package supports most sequenced genomes. Mouse mm10 sequence can be 
downloaded as follows:  
<!-- Installation code below is for demonstration and not evaluated -->
```{r genomeBSgenome, eval=FALSE}  
if (!requireNamespace("BiocManager", quietly = TRUE))  
    install.packages("BiocManager")  
  
BiocManager::install("BSgenome.Mmusculus.UCSC.mm10")  
```  
  
and loaded into R environment:  
  
```{r loadBSgenome}  
library(BSgenome.Mmusculus.UCSC.mm10)
Mmusculus <- BSgenome.Mmusculus.UCSC.mm10
```  
  
2. Using *AnnotationHub*  
```{r genomeAhub}  
library(AnnotationHub)   
ah <- AnnotationHub()  
query(ah, c("mm10","2bit"))   
```

<!-- Code below not evaluated as it serves as an alternative method of retrieving genome data -->
```{r, eval=FALSE}
# Retrieve mouse genome
Mmusculus <- ah[['AH14005']]  
```  
  
3. Downloading from a database (e.g. GENCODE)  
<!-- Code below not evaluated as it serves as an alternative method of retrieving genome data -->
```{r downloadGencode, eval=FALSE}  
tmp <- tempfile()
download.file("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_M25/GRCm38.primary_assembly.genome.fa.gz",  
              tmp)  
Mmusculus <- importFASTA(paste0(tmp, "/GRCm38.primary_assembly.genome.fa.gz"))  
```  
 
Once the genome sequence object is ready, *factR* can predict CDSs using its 
buildCDS() function and reference transcriptome data as a guide. buildCDS() 
first generates a database of previously annotated ATGs and uses this 
information to search for a potential translation start sites in query 
transcripts. buildCDS() then deduces the CDS and appends its coordinates to 
the custom transcriptome object. Let's run this function for our novel 
transcripts:  
```{r buildcds, warning=FALSE}  
custom_new_CDS.gtf <- buildCDS(custom_new.gtf, ref.gtf, Mmusculus)  
```  
  
Note that the novel *Zfr* transcripts have been updated with information
about likely CDSs (dark blue) and untranslated regions (light blue) :  
```{r viewafterCDS}  
viewTranscripts(custom_new_CDS.gtf, "Zfr")  
```  
  
We can display exonic regions and CDSs more clearly (at the expense of 
loosing their bona fide genomic coordinates) by setting rescale_intron 
argument to TRUE.   
```{r viewafterCDSscale}  
viewTranscripts(custom_new_CDS.gtf, "Zfr", rescale_introns = TRUE)  
```  
  
For comparison, here is the CDS situation in the reference Zfr transcripts:  
```{r viewrefCDS}   
viewTranscripts(ref.gtf, "Zfr", rescale_introns = TRUE)  
```  
  
## Predicting NMD  
To explore possible susceptibility of newly identified mRNA isoforms to NMD, 
we use the `predictNMD` function:  
```{r predictNMD1, warning=FALSE}  
NMDprediction.out <- predictNMD(custom_new_CDS.gtf)  

head(NMDprediction.out)  
```  
  
`predictNMD` outputs a data frame containing information on features that may 
promote NMD and predicts NMD sensitivity for each CDS-containing transcript 
based on the distance between the stop codon and the last exon-exon junction.    
  
To identify putative NMD targets for specific genes (e.g. *Zfr*), run the following:  
```{r predictNMD2}  
NMDprediction.Zfr <- predictNMD(custom_new_CDS.gtf, gene_name == "Zfr") 

head(NMDprediction.Zfr)  
```  
  
## Predicting protein domains  
*factR* can also inspect domain structure of protein products encoded by newly 
identified mRNA isoforms using its `predictDomains()` function. This requires 
connection to the online PFAM database and may require a substantial amount of 
time and stable internet connection to query multiple transcripts 
simultaneously. To quickly explore functionality of the `predictDomains()` tool,
users may prefer to begin with a relatively small subset of transcripts. 
For example, the following will predict domain structure for all transcripts 
of the Zfr gene:
```{r predDomain2}  
predictDomains(custom_new_CDS.gtf, Mmusculus, gene_name == "Zfr", progress_bar = FALSE)  
```  
  
The domain architectures for the set of query proteins can be additionally 
plotted by switching the argument "plot" to TRUE:  
```{r predDomain3, eval = F}  
domains.Zfr <- predictDomains(custom_new_CDS.gtf, Mmusculus, gene_name == "Zfr", plot = TRUE, progress_bar = FALSE)  
```  
  
If you want to predict domains for all new transcripts and do not mind waiting 
for some time depending on the connection speed and the PFAM server load, 
run the following:
```{r predDomain1, eval=FALSE}  
domains.out <- predictDomains(custom_new_CDS.gtf, Mmusculus, progress_bar = FALSE)  
```  
  
## Export output objects  
Annotated *custom_new_CDS.gtf* object can be exported to a GTF file as follows:  
```{r exportgtf, eval=FALSE}  
library(rtracklayer) 
export(custom_new_CDS.gtf, "Custom_new.gtf", format = "GTF")  
```  
  
Finally, to export *NMDprediction.out* and *domains.out* data frames as 
tab-delimited text files, run the following:  
```{r exporttable, eval=FALSE}  
write.table(NMDprediction.out, "Custom_new_NMD.txt", sep = "\t", row.names = FALSE, quote = FALSE)  
write.table(domains.out, "Custom_new_domains.txt", sep = "\t", row.names = FALSE, quote = FALSE)  
```  
  
# Citing *factR*  
Please cite *factR* if you find it useful:  
<!-- Citation will be added in the near future -->  
  
  
# Session Information  
This workflow was conducted on:  
```{r sessioninfo}  
sessionInfo()  
```  
  
  
# References  
 
 

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eachfunctions.R
\name{mutateeach}
\alias{mutateeach}
\title{Internally create or transform metadata of a GenomicRangesList}
\usage{
mutateeach(x, ...)
}
\arguments{
\item{x}{GRangesList object}

\item{...}{Name-value pairs of expressions. The name of each argument will be the name
of a new metadata column, and the value will be its corresponding value.}
}
\value{
Transformed GRangesList object
}
\description{
Internally create or transform metadata of a GenomicRangesList
}
\examples{
# Load dataset
data(query_exons)

# Create chr:start-end id for each entry
mutateeach(query_exons, id = paste0(seqnames, ":", start, "-", end))
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{ref_exons}
\alias{ref_exons}
\title{Exons from 2 reference transcripts entries of the same gene}
\format{
A GRangesList object with 2 elements:
\describe{
  \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
  and its exons}
  \item{type}{Entry type; transcript or exon}
  \item{phase}{Phase of open-reading frame}
  \item{gene_id}{Matched gene_id}
  \item{gene_name}{Name of gene}
  \item{transcript_id}{ID given to transcripts}
  ...
}
}
\source{
\url{https://www.gencodegenes.org/}
}
\usage{
data(ref_exons)
}
\description{
A dataset containing coordinates of exons from 2 reference transcripts of
mouse Ptbp1.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{domains.known}
\alias{domains.known}
\title{Example output of predictDomains()}
\format{
A data.frame with 85780 rows and 5 columns:
\describe{
  \item{transcript}{Transcript ID of protein-coding RNAs}
  \item{description}{Name of domain families}
  \item{eval}{E-value score}
  \item{begin}{Start position of domain in protein}
  \item{end}{End position of domain in protein}
  ...
}
}
\usage{
data(domains.known)
}
\description{
Output dataframe from predictDomains() function. mRNAs from GENCODE
mouse annotation was predicted for putative domain families.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{query_gtf}
\alias{query_gtf}
\title{Imported GTF file containing 4 transcript entries of the same gene}
\format{
A GRanges object with 56 ranges and 3 metadata columns:
\describe{
  \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
  and its exons}
  \item{type}{Entry type; transcript or exon}
  \item{transcript_id}{Name or ID given to transcripts}
  \item{gene_id}{Name or ID given to gene origin of transcripts}
  ...
}
}
\source{
\url{http://www.ensembl.org/}
}
\usage{
data(query_gtf)
}
\description{
A dataset containing coordinates of transcript and exons from 4 transcripts 
of mouse Ptbp1. Transcript names and gene IDs have been modified to 
demonstrate de novo origin of GTF
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eachfunctions.R
\name{sorteach}
\alias{sorteach}
\title{Internally sort each element of a GenomicRangesList}
\usage{
sorteach(x, ...)
}
\arguments{
\item{x}{GRangesList object}

\item{...}{Comma separated list of unquoted variable names to sort by. Variables are 
names of metadata columns found in GRangesList object. Use desc() to sort a
variable in descending order. Input can be `exonorder` to sort each element 
in exon order}
}
\value{
Sorted GRangesList object
}
\description{
Internally sort each element of a GenomicRangesList
}
\examples{
# Load dataset
data(query_exons)

# sort elements in each GRangesList in descending coordinate order
query_exons_desc <- sorteach(query_exons, dplyr::desc(start))

# sort elements in each GRangesList in its order in transcript
query_exons_exonorder <- sorteach(query_exons_desc, exonorder)

# test similarity of query_exons and query_exons_exonorder
identical(query_exons, query_exons_exonorder)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trimTranscripts.R
\name{trimTranscripts}
\alias{trimTranscripts}
\title{Resize 5' and 3' ends of a transcript GenomicRanges}
\usage{
trimTranscripts(x, start = 0, end = 0)
}
\arguments{
\item{x}{GRanges or GRangesList object containing exon coordinates for each transcript}

\item{start}{Number of bases to trim from the start of transcript. Providing a negative 
value will extend the transcript instead. If `x` is a GRanges object,
`start` is a single integer. If `x` is a GRangesList, `start` can be a single
integer or a list of integers of the same length as `x`}

\item{end}{Number of bases to trim from the end of transcript. Providing a negative 
value will extend the transcript instead. If `x` is a GRanges object,
`end` is a single integer. If `x` is a GRangesList, `end` can be a single
integer or a list of integers of the same length as `x`}
}
\value{
Trimmed GenomicRanges object
}
\description{
Resize 5' and 3' ends of a transcript GenomicRanges
}
\examples{
library(GenomicRanges)
gr1 <- GRanges(
  seqnames = "chr1", strand = c("+", "+", "+"),
  ranges = IRanges(
    start = c(1, 500, 1000),
    end = c(100, 600, 1100)
  )
)

trimTranscripts(gr1, 20, 80)
trimTranscripts(gr1, 110, 150)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/buildCDS.R
\name{buildCDS}
\alias{buildCDS}
\title{Reference-guided construction of CDS on GTF object}
\usage{
buildCDS(query, ref, fasta)
}
\arguments{
\item{query}{GRanges object containing query GTF data.}

\item{ref}{GRanges object containing reference GTF data.}

\item{fasta}{BSgenome or Biostrings object containing genomic sequence}
}
\value{
GRanges object containing query exon entries and newly-constructed CDS
information
}
\description{
`buildCDS()` is designed to construct CDS information on transcripts from
query GTF object.
}
\details{
The `buildCDS()`function will first search for known reference mRNAs in
`query` and annotate its CDS information. For the remaining transcripts, 
`buildCDS()` will search for a putative translation start site using a 
database of annotated ATG codons from `ref`. Transcripts containing an 
open-reading frame will be assigned the newly-determined CDS information.
}
\examples{
# Load genome and datasets
library(BSgenome.Mmusculus.UCSC.mm10)
data(matched_query_gtf, ref_gtf)

# Build CDS
buildCDS(matched_query_gtf, ref_gtf, Mmusculus)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/has_consistentSeqLevels.R
\name{has_consistentSeqlevels}
\alias{has_consistentSeqlevels}
\title{Test consistency of chromosome naming styles 
(aka seqlevels; e.g. "chr1" vs "1") across multiple objects}
\usage{
has_consistentSeqlevels(..., verbose = TRUE)
}
\arguments{
\item{...}{Two or more objects with seqlevels information}

\item{verbose}{Whether to print out message}
}
\value{
Logical value as to whether all objects have consistent 
seqlevel styles
}
\description{
This function will determine if all input ranges objects have the 
same chromosome naming convention. Input objects can be GenomicRanges, 
BSgenome or Biostrings object with seqlevel information.
}
\examples{
## ---------------------------------------------------------------------
## EXAMPLE USING TOY DATASET
## ---------------------------------------------------------------------
require(GenomicRanges)

## Create toy GRanges objects
gr1 <- GRanges("1", IRanges(start = c(1, 101), width = c(20, 20)), "+")
gr2 <- GRanges("chr1", IRanges(start = c(1, 101), width = c(20, 20)), "+")

## Test for seqlevels consistency
has_consistentSeqlevels(gr1, gr2)

## Input can be a Biostrings object with seqlevels information
x0 <- c("chr2" = "CTCACCAGTAT", "chr3" = "TGTCAGTCGA")
dna <- Biostrings::DNAStringSet(x0)

## Test for seqlevels consistency
has_consistentSeqlevels(gr1, dna)
has_consistentSeqlevels(gr2, dna)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictDomains.R
\name{predictDomains}
\alias{predictDomains}
\title{Predict protein domain families from coding transcripts}
\usage{
predictDomains(x, fasta, ..., plot = FALSE, progress_bar = FALSE, ncores = 4)
}
\arguments{
\item{x}{Can be a GRanges object containing 'CDS' features in GTF format

Can be a GRangesList object containing CDS ranges for each transcript}

\item{fasta}{BSgenome or Biostrings object containing genomic sequence}

\item{...}{Logical conditions to pass to dplyr::filter to subset transcripts for 
analysis. Variables are metadata information found in `x` and multiple 
conditions can be provided delimited by comma. 
Example: transcript_id == "transcript1"}

\item{plot}{Argument whether to plot out protein domains (Default: FALSE).
Note: only first 20 proteins will be plotted}

\item{progress_bar}{Argument whether to show progress bar (Default: FALSE). Useful to track
progress of predicting a long list of proteins.}

\item{ncores}{Number of cores to utilise to perform prediction}
}
\value{
Dataframe containing protein features for each cds entry
}
\description{
Predict protein domain families from coding transcripts
}
\examples{
## ---------------------------------------------------------------------
## EXAMPLE USING SAMPLE DATASET
## ---------------------------------------------------------------------
# Load Mouse genome sequence
library(BSgenome.Mmusculus.UCSC.mm10)

# Load dataset
data(new_query_gtf)

# predict domains of all CDSs in query GTF
predictDomains(new_query_gtf, Mmusculus, ncores=1)

# predict domains of CDSs from Ptbp1 gene
predictDomains(new_query_gtf, Mmusculus, gene_name == "Ptbp1",ncores=1)

# predict domains of CDSs from Ptbp1 gene and plot architecture out
predictDomains(new_query_gtf, Mmusculus, gene_name == "Ptbp1", plot = TRUE,ncores=1)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matchGeneInfo.R
\name{matchGeneInfo}
\alias{matchGeneInfo}
\title{Match gene metadata from query GTF to a reference GTF}
\usage{
matchGeneInfo(query, ref, primary_gene_id = NULL, secondary_gene_id = NULL)
}
\arguments{
\item{query}{Query GTF imported as GRanges object}

\item{ref}{Reference GTF as GRanges object}

\item{primary_gene_id}{Character name of the primary gene id metadata in query GTF.
Input to this argument is typically 'gene_id'}

\item{secondary_gene_id}{Character name of the secondary gene id in query file.
Example of input to this argument is 'ref_gene_id'}
}
\value{
Gene_id-matched query GRanges
}
\description{
`matchGeneInfo()` matches and corrects Gene IDs from a 
query GTF object to a reference GTF
}
\details{
The default approach to this correction relies on finding overlaps 
between transcripts in query with transcripts in reference. Using this 
method alone could result in false positive matches 
(19 percent false positives).
To improve this, users have the option to invoke two additional layers 
of matching.  
(1) Matching by ENSEMBL Gene_IDs. If both query and reference transcript 
annotations containg Ensembl-style Gene IDs, this program will try to 
match both IDs in a less stringent manner. This correction can be invoked
by providing the 'primary_gene_id' argument

(2) Matching by secondary Gene_IDs. Depending on the transcript assembly 
program, GTF/GFF3 annotations may contain additional comments on the
transcript information. This may include a distinct secondary Gene ID 
annotation that potentially matches with the reference. To invoke this 
correction, provide 'primary_gene_id' and 'secondary_gene_id' arguments. 
To determine if your transcript assembly contain possible secondary 
Gene IDs, import query GTF file using `importGTF()` and check its metadata
columns
}
\examples{
## ---------------------------------------------------------------------
## EXAMPLE USING SAMPLE DATASET
## ---------------------------------------------------------------------
# Load datasets
data(chrom_matched_query_gtf, ref_gtf)

# Run matching function
matchGeneInfo(chrom_matched_query_gtf, ref_gtf)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eachfunctions.R
\name{filtereach}
\alias{filtereach}
\title{Internally filter each element of a GenomicRangesList}
\usage{
filtereach(x, ...)
}
\arguments{
\item{x}{GRangesList object}

\item{...}{Logical conditions to filter each element in the GRanges by. 
Multiple conditions can be provided as comma-delimited inputs}
}
\value{
Filtered GRangesList object
}
\description{
Internally filter each element of a GenomicRangesList
}
\examples{
# Load dataset
data(query_exons)

# select first element of each GRangesList item
filtereach(query_exons, dplyr::row_number() == 1)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/import.R
\name{importGTF}
\alias{importGTF}
\title{Import GTF file into R}
\usage{
importGTF(con)
}
\arguments{
\item{con}{Path to GTF file}
}
\value{
Imported GenomicRanges object in GTF format
}
\description{
This function loads GTF files into R and converts it into


a wrapper to rtracklayer::import() function to conveniently
import GTF file into R as a GenomicRanges object.
}
\examples{
gtf <- system.file("extdata", "sc_merged_sample.gtf.gz", package = "factR")
importGTF(gtf)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{query_exons}
\alias{query_exons}
\title{GRangeList of exons from 4 transcripts entries from query_gtf}
\format{
A GRangesList object with 4 elements:
\describe{
  \item{ranges}{Chromosome, start, end, and strand info of 4 transcripts
  and its exons}
  \item{type}{Entry type; transcript or exon}
  \item{transcript_id}{ID given to transcripts}
  \item{gene_id}{Matched gene_id}
  \item{old_gene_id}{Original gene_id}
  \item{match_level}{Level of matching performed}
  \item{gene_name}{Name of gene}
  ...
}
}
\usage{
data(query_exons)
}
\description{
A dataset containing coordinates of exons from 4 transcripts of
mouse Ptbp1. Transcript names and gene IDs have been modified
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subsettranscripts.R
\name{subsetNewTranscripts}
\alias{subsetNewTranscripts}
\title{Shortlist GTF GRanges object for new transcripts}
\usage{
subsetNewTranscripts(query, ref, refine.by = c("none", "intron", "cds"))
}
\arguments{
\item{query}{GRanges object containing query GTF data.}

\item{ref}{GRanges object containing reference GTF data.}

\item{refine.by}{Whether to refine the selection process by removing query transcripts with
similar introns or CDS structure to reference. Default input is "none", and 
can be changed to "intron" or "cds" respectively.}
}
\value{
Filtered GRanges GTF object
}
\description{
`subsetNewTranscripts()` will retain transcripts in `query` that are distinct
from those in `ref`
}
\details{
`subsetNewTranscripts()` will compare query and reference GTF GRanges and 
return query transcripts with different exon structures from reference 
transcripts. Transcriptome assemblers may sometime extend 5' and 3' ends 
of known transcripts based on experimental data. These annotated transcripts 
can be removed by inputting "intron" to the refine.by argument. This will 
further compare and remove transcripts of identical intron structures. 
Alternatively, transcripts with unique CDS coordinates can be selected by 
typing "cds" to the refine.by argument.
}
\examples{
# Load dataset
data(matched_query_gtf, ref_gtf)

# shortlist new transcripts
subsetNewTranscripts(matched_query_gtf, ref_gtf)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictNMD.R
\name{predictNMD}
\alias{predictNMD}
\title{Predict NMD sensitivity on mRNA transcripts}
\usage{
predictNMD(x, ..., cds = NULL, NMD_threshold = 50, progress_bar = TRUE)
}
\arguments{
\item{x}{Can be a GRanges object containing exon and CDS transcript features in GTF
format.

Can be a GRangesList object containing exon features for a list of 
transcripts.If so, `cds` argument have to be provided.

Can be a GRanges object containing exon features for a transcript. 
If so, `cds` argument have to be provided.}

\item{...}{Logical conditions to pass to dplyr::filter to subset transcripts for 
analysis. Variables are metadata information found in `x` and multiple 
conditions can be provided delimited by comma. 
Example: transcript_id == "transcript1"}

\item{cds}{If `x` is a GRangesList object, `cds` has to be a GRangesList containing 
CDS features for the list of transcripts in `x`. List names in `x` and 
`cds` have to match.

If `x` is a GRanges object, `cds` has to be a GRanges containing CDS 
features for the transcript in `x`.}

\item{NMD_threshold}{Minimum distance of stop_codon to last exon junction 
(EJ) which triggers NMD. Default = 50bp}

\item{progress_bar}{Whether to display progress 
Default = TRUE}
}
\value{
Dataframe with prediction of NMD sensitivity and NMD features:

is_NMD: logical value in prediciting transcript sensitivity to NMD

stop_to_lastEJ: Integer value of the number of bases between the first
base of the stop_codon to the last base of EJ. A positive value indicates 
that the last EJ is downstream of the stop_codon.

num_of_down_EJs: Number of EJs downstream of the stop_codon.

`3_UTR_length`: Length of 3' UTR
}
\description{
Predict NMD sensitivity on mRNA transcripts
}
\examples{

## ---------------------------------------------------------------------
## EXAMPLE USING SAMPLE DATASET
## ---------------------------------------------------------------------

# Load datasets
data(new_query_gtf, query_exons, query_cds)

## Using GTF GRanges as input
predictNMD(new_query_gtf)

### Transcripts for analysis can be subsetted using logical conditions
predictNMD(new_query_gtf, transcript_id == "transcript1")
predictNMD(new_query_gtf, 
transcript_id \%in\% c("transcript1", "transcript3"))


## Using exon and CDS GRangesLists as input
predictNMD(query_exons, cds = query_cds)
predictNMD(query_exons, cds = query_cds, transcript_id == "transcript3")


## Using exon and CDS GRanges as input
predictNMD(query_exons[[3]], cds = query_cds[[3]])



## ---------------------------------------------------------------------
## EXAMPLE USING TRANSCRIPT ANNOTATION
## ---------------------------------------------------------------------
\donttest{
library(AnnotationHub)

## Retrieve GRCm38 trancript annotation
ah <- AnnotationHub()
GRCm38_gtf <- ah[["AH60127"]]

## Run tool on specific gene family
predictNMD(GRCm38_gtf, gene_name == "Ptbp1")
}

}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/viewTranscripts.R
\name{viewTranscripts}
\alias{viewTranscripts}
\title{Plot transcripts directly from GTF.}
\usage{
viewTranscripts(x, ..., rescale_introns = FALSE, ncol = 1)
}
\arguments{
\item{x}{GRanges object containing transcript annotation in GTF format}

\item{...}{Character value of features to plot. Multiple features can be plotted by
entering comma-delimited values. Features will be extracted from
metadata gene_name, gene_id and transcript_id of the GTF. Can also be a
conditional statement to filter values from variables in the GTF (e.g. gene_name == "Ptbp1")}

\item{rescale_introns}{Specifies if the introns should be scaled to fixed length or not. (default: FALSE)}

\item{ncol}{Number of columns to patch the output plots (default: 1)}
}
\value{
ggplot2 object. If multiple genes are detected, plots will be 
combined using patchwork
}
\description{
A wrapper around wiggleplotr's plotTranscripts function. 
See the documentation for (\code{\link[wiggleplotr]{plotTranscripts}})
for more information.
}
\examples{
## ---------------------------------------------------------------------
## EXAMPLE USING SAMPLE DATASET
## ---------------------------------------------------------------------
# Load datasets
data(query_gtf, ref_gtf)

viewTranscripts(query_gtf)
viewTranscripts(query_gtf, "transcript1")
viewTranscripts(ref_gtf)

## ---------------------------------------------------------------------
## EXAMPLE USING TRANSCRIPT ANNOTATION
## ---------------------------------------------------------------------
\donttest{
library(AnnotationHub)

## Retrieve GRCm38 trancript annotation
ah <- AnnotationHub()
GRCm38_gtf <- ah[["AH60127"]]

## Plot transcripts from Ptbp1 gene
viewTranscripts(GRCm38_gtf, "Ptbp1")

# Plot transcripts from Ptbp1 and Ptbp2 genes
viewTranscripts(GRCm38_gtf, "Ptbp1", "Ptbp2")
}

}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matchChromosomes.R
\name{matchChromosomes}
\alias{matchChromosomes}
\title{Match seqlevels of input GRanges to reference GRanges or BioString objects}
\usage{
matchChromosomes(x, to)
}
\arguments{
\item{x}{GRanges object with seqnames to change}

\item{to}{GRanges object from which seqnames is referenced}
}
\value{
Corrected input GRanges
}
\description{
A convenient wrapper to match seqlevels of a query GRanges object to a 
reference object that contain seqlevels information. Reference can be a 
GRanges, GRangesList, BioString or DNAString object. Seqlevels which fail 
to match will be dropped.
}
\examples{
## ---------------------------------------------------------------------
## EXAMPLE USING TOY DATASET
## ---------------------------------------------------------------------
require(GenomicRanges)

## Create toy GRanges objects
gr1 <- GRanges("1", IRanges(start = c(1, 101), width = c(20, 20)), "+")
gr2 <- GRanges("chr1", IRanges(start = c(1, 101), width = c(20, 20)), "+")

## Match Ensembl-style chromosomes from gr1 to UCSC-style gr2
matchChromosomes(gr1, gr2)

## Possible to match chrosomomes from GRanges object to a Biostrings 
#    object containing seqlevels
x0 <- c("chr2" = "CTCACCAGTAT", "chr3" = "TGTCAGTCGA")
dna <- Biostrings::DNAStringSet(x0)

## Match gr1 to dna
matchChromosomes(gr1, dna)
}
\author{
Fursham Hamid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/import.R
\name{importFASTA}
\alias{importFASTA}
\title{Import FASTA file into R}
\usage{
importFASTA(con)
}
\arguments{
\item{con}{Path to FASTA file}
}
\value{
Imported DNAStringSet object
}
\description{
This function is a wrapper to Biostrings::readDNAStringSet() 
function to import FASTA genome sequence file and simultaneously 
convert long chromosome names 
(e.g. 1 dna:chromosome chromosome:GRCm38:1:1:195471971:1 REF) 
to short names (e.g. 1)
}
\author{
Fursham Hamid
}
